/*
 *  JFrameSpectrum.java
 *  Version 1beta0
 *  Created on January 29, 2002, 1:31 PM
 *  @author  Marco Parvis
 */

/*
    Questo e' JFrameAnal una parte di Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
    This is JFrameAnal part of the Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
 */

/*
    Questo  programma e'  software  libero; e'  lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come e' pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.
 
    Questo programma  e' distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILITA'  o di  APPLICABILITA' PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.
 
    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne puo'
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA
 
    L'autore puo' essere contattato a parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 */

/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA
 
    The author can be contacted at parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 
 */

/*
 * This panel provides a simple spectrum analyzer
 */





package JavaScope;
import javax.swing.*;
import java.awt.*;
import java.util.*;
/**
 *
 * @author  admsermis
 */
public class JFrameAnal extends javax.swing.JFrame implements VirtualPanel{ // Observer{
    
    private String panelIdString;
    private boolean useCalibrationFactor=false;
    private double calFactorVoltAtBitCh1=1;
    private double calFactorVoltAtBitCh2=1;
    private String lastSaveDir="";
    private final int  ACQ_LEN=20000;
    private boolean flashOn=false;
    private long lastTrigTime=0;
    
    private boolean weAreInABench=false;
    private InputManager man;
    private java.util.Timer timerMonitor;
    
    private ScopeMonitor scopeMonitor;
    
    private int[] inputData=new int[ACQ_LEN];
    //  private int[] inputTrig=new int[ACQ_LEN];
    private int w = 10; //last computed plot screen width
    private int h = 10; //last computed plot screen height;
    private int[] xScreen=new int[ACQ_LEN];    //x positions on plot screen
    private int[] yChannel1=new int[ACQ_LEN];  //scaled channels
    private int availSamples=0;
    private boolean gotTrig=false;
    private boolean doNotListen=false;
    
    private int xStart=0;
    private int xStop=ACQ_LEN;
    private boolean recompute=false;
    /** Creates new form jFrameSpectrum */
    public JFrameAnal() {
        
        initComponents();
        
        this.jComboBoxYScale.addItem("40");
        this.jComboBoxYScale.addItem("60");
        this.jComboBoxYScale.addItem("80");
        this.jComboBoxYScale.addItem("100");
        this.jComboBoxYScale.addItem("120");
        this.jComboBoxYScale.setSelectedIndex(3);
        
        
        
        this.jComboBoxAverage.addItem("1");
        this.jComboBoxAverage.addItem("2");
        this.jComboBoxAverage.addItem("4");
        this.jComboBoxAverage.addItem("8");
        this.jComboBoxAverage.addItem("16");
        this.jComboBoxAverage.addItem("32");
        this.jComboBoxAverage.addItem("64");
        this.jComboBoxAverage.addItem("128");
        this.jComboBoxAverage.addItem("256");
        this.jComboBoxAverage.setSelectedIndex(0);
        
        
        
        weAreInABench=false;
        scopeMonitor=new ScopeMonitor();
        timerMonitor=new java.util.Timer();
        timerMonitor.scheduleAtFixedRate(scopeMonitor,500,500);
        
    }
    public JFrameAnal(InputManager im) {
        initComponents();
        
        this.jComboBoxYScale.addItem("40");
        this.jComboBoxYScale.addItem("60");
        this.jComboBoxYScale.addItem("80");
        this.jComboBoxYScale.addItem("100");
        this.jComboBoxYScale.addItem("120");
        this.jComboBoxYScale.setSelectedIndex(3);
        
        
        this.jComboBoxAverage.addItem("1");
        this.jComboBoxAverage.addItem("2");
        this.jComboBoxAverage.addItem("4");
        this.jComboBoxAverage.addItem("8");
        this.jComboBoxAverage.addItem("16");
        this.jComboBoxAverage.addItem("32");
        this.jComboBoxAverage.addItem("64");
        this.jComboBoxAverage.addItem("128");
        this.jComboBoxAverage.addItem("256");
        this.jComboBoxAverage.setSelectedIndex(0);
        
        //this.jComboBoxNPoints.setSelectedIndex(1);
        weAreInABench=true;
        scopeMonitor=new ScopeMonitor();
        timerMonitor=new java.util.Timer();
        timerMonitor.scheduleAtFixedRate(scopeMonitor,500,500);
        
    }
    
    public void useOutputCalibration(boolean use){
    }
    public void useInputCalibration(boolean use){
        this.useCalibrationFactor=use;
    }
    public void setOutputCalibration(double newCalCh1,double newCalCh2){
    }
    public void setInputCalibration(double newCalCh1,double newCalCh2){
        this.calFactorVoltAtBitCh1=newCalCh1;
        this.calFactorVoltAtBitCh2=newCalCh2;
    }
    
    public String getSettings(){
        int x=this.getLocation().x;
        int y=this.getLocation().y;
        int w=this.getSize().width;
        int h=this.getSize().height;
        
        String s=panelIdString+"|Position="+String.valueOf(x)+","+String.valueOf(y)+"|Size="+String.valueOf(w)+","+String.valueOf(h)+"|";
        if (this.useCalibrationFactor)
            s=s+"UseInputCal=1|";
        else
            s=s+"UseInputCal=0|";
        s=s+"InputCalFactors="+String.valueOf(this.calFactorVoltAtBitCh1)+","+String.valueOf(this.calFactorVoltAtBitCh2);
        s=s+"|LastDir="+this.lastSaveDir;
        return s;
    }
    public void applySettings(String settings){
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        StringTokenizer tokens=new StringTokenizer(settings,"|");
        while (tokens.hasMoreTokens()){
            String token=tokens.nextToken();
            //browse through recognized tokens
            if (token.indexOf("Position=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<1) x=1;
                    if (x>screenSize.width-10) x=screenSize.width-10;
                    if (y<1) y=1;
                    if (y>screenSize.height-10) y=screenSize.height-10;
                    this.setLocation(x,y);
                }catch (Throwable t){}
                
            }else if (token.indexOf("Size=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<10) x=10;
                    if (x>screenSize.width-20) x=screenSize.width-20;
                    if (y<10) y=10;
                    if (y>screenSize.height-20) y=screenSize.height-20;
                    this.setSize(x,y);
                }catch (Throwable t){}
            }else if (token.indexOf("UseInputCal=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    if (x!=0)
                        this.useCalibrationFactor=true;
                    else
                        this.useCalibrationFactor=false;
                }catch (Throwable t){}
            }else if (token.indexOf("InputCalFactors=")>=0){
                String[] p=getValues(token);
                try{
                    double x=new Double(p[0]).doubleValue();
                    double y=new  Double(p[1]).doubleValue();
                    this.calFactorVoltAtBitCh1=x;
                    this.calFactorVoltAtBitCh2=y;
                }catch (Throwable t){}
                
            }else if (token.indexOf("LastDir=")>=0){
                String[] p=getValues(token);
                try{
                    this.lastSaveDir=p[0];
                }catch (Throwable t){}
            }
        }
        
    }
    private String[] getValues(String s){
        int peq=s.indexOf("=");
        if (peq>0){
            StringTokenizer ss=new StringTokenizer(s.substring(peq+1),",");
            if (ss.countTokens()>0){
                String[] vl=new String[ss.countTokens()];
                for (int i=0;i<vl.length;i++)
                    vl[i]=ss.nextToken();
                return vl;
            }else
                return new String[0];
            
        }else
            return new String[0];
    }
    public void setOutputManager(OutputManager im){
    }
    public void setInputManager(InputManager im){
        this.man=im;
        man.addObserver(this);
    }
    public void setBenchComponent(boolean bc){
        weAreInABench=bc;
        if (bc)
            this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        else
            this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        
    }
    public void setIdString(String s){
        this.panelIdString=s;
        this.setTitle(s);
    }
    public String getIdString(){
        return this.panelIdString;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanelBase = new javax.swing.JPanel();
        jPanelSpectrum = new SpectrumScreen();
        jPanelSpectrumCommands = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jComboBoxYScale = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jComboBoxAverage = new javax.swing.JComboBox();
        jPanelLampTrig = new SignalPanel();
        jButtonCalibration = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabelSpan = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldDisplaySpan = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldDisplayStart = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jButtonSetZoom = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jToolBarSpectrum = new javax.swing.JToolBar();
        jButtonSaveTrace = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanelBase.setLayout(null);

        jPanelBase.setBackground(java.awt.Color.red);
        jPanelBase.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanelBaseComponentResized(evt);
            }
        });

        jPanelSpectrum.setBorder(new javax.swing.border.EtchedBorder());
        jPanelSpectrum.setMinimumSize(new java.awt.Dimension(20, 20));
        jPanelSpectrum.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanelSpectrum.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentMoved(java.awt.event.ComponentEvent evt) {
                jPanelSpectrumComponentMoved(evt);
            }
        });

        jPanelBase.add(jPanelSpectrum);
        jPanelSpectrum.setBounds(200, 10, 320, 190);

        jPanelSpectrumCommands.setLayout(new java.awt.GridBagLayout());

        jPanelSpectrumCommands.setBorder(new javax.swing.border.EtchedBorder());
        jLabel2.setText("Y Scale");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jLabel2, gridBagConstraints);

        jComboBoxYScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxYScaleActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jComboBoxYScale, gridBagConstraints);

        jLabel4.setText("Aver.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jLabel4, gridBagConstraints);

        jComboBoxAverage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxAverageActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jComboBoxAverage, gridBagConstraints);

        jPanelLampTrig.setBackground(new java.awt.Color(204, 204, 204));
        jPanelLampTrig.setMinimumSize(new java.awt.Dimension(12, 12));
        jPanelLampTrig.setPreferredSize(new java.awt.Dimension(12, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.insets = new java.awt.Insets(20, 0, 0, 0);
        jPanelSpectrumCommands.add(jPanelLampTrig, gridBagConstraints);

        jButtonCalibration.setText("Calibrate");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 20, 10);
        jPanelSpectrumCommands.add(jButtonCalibration, gridBagConstraints);

        jLabel1.setText("Total Span");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jLabel1, gridBagConstraints);

        jLabelSpan.setText("10");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 20;
        jPanelSpectrumCommands.add(jLabelSpan, gridBagConstraints);

        jLabel5.setText("Display Span");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jLabel5, gridBagConstraints);

        jTextFieldDisplaySpan.setText("10");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelSpectrumCommands.add(jTextFieldDisplaySpan, gridBagConstraints);

        jLabel6.setText("Display Start");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jLabel6, gridBagConstraints);

        jTextFieldDisplayStart.setText("0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelSpectrumCommands.add(jTextFieldDisplayStart, gridBagConstraints);

        jLabel7.setText("Gate");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(20, 5, 0, 5);
        jPanelSpectrumCommands.add(jLabel7, gridBagConstraints);

        jButtonSetZoom.setText("Set Zoom");
        jButtonSetZoom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSetZoomActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 10, 20);
        jPanelSpectrumCommands.add(jButtonSetZoom, gridBagConstraints);

        jLabel8.setText("MHz");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanelSpectrumCommands.add(jLabel8, gridBagConstraints);

        jLabel9.setText("MHz");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanelSpectrumCommands.add(jLabel9, gridBagConstraints);

        jLabel10.setText("MHz");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanelSpectrumCommands.add(jLabel10, gridBagConstraints);

        jPanelBase.add(jPanelSpectrumCommands);
        jPanelSpectrumCommands.setBounds(10, 10, 170, 210);

        getContentPane().add(jPanelBase, java.awt.BorderLayout.CENTER);

        jButtonSaveTrace.setIcon(new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/save.gif")));
        jButtonSaveTrace.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonSaveTrace.setMinimumSize(new java.awt.Dimension(20, 24));
        jButtonSaveTrace.setPreferredSize(new java.awt.Dimension(20, 24));
        jToolBarSpectrum.add(jButtonSaveTrace);

        getContentPane().add(jToolBarSpectrum, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents
    
    private void jButtonSetZoomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSetZoomActionPerformed
        // Add your handling code here:
        try{
            double sp=
            Double.valueOf(this.jLabelSpan.getText()).doubleValue();
            double rsp=
            Double.valueOf(this.jTextFieldDisplaySpan.getText()).doubleValue();
            if (rsp>sp){
                this.jTextFieldDisplaySpan.setText(this.jLabelSpan.getText());
                xStart=0;
                xStop=ACQ_LEN;
                recompute=true;
                return;
            }
            
            
            double st=
            Double.valueOf(this.jTextFieldDisplayStart.getText()).doubleValue();
            if ((st+rsp)>sp){
                st=sp-rsp;
                this.jTextFieldDisplayStart.setText(new Double(st).toString());
            }
            xStart=(int)(ACQ_LEN*st/sp);
            xStop=(int)(xStart+ACQ_LEN*rsp/sp);
            
            recompute=true;
        }catch (NumberFormatException n) {
            this.jTextFieldDisplaySpan.setText(this.jLabelSpan.getText());
            this.jTextFieldDisplaySpan.setText("0");
            xStart=0;
            xStop=ACQ_LEN;
            recompute=true;
        }
    }//GEN-LAST:event_jButtonSetZoomActionPerformed
    
    private void jComboBoxAverageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxAverageActionPerformed
        
    }//GEN-LAST:event_jComboBoxAverageActionPerformed
    
    private void jComboBoxYScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxYScaleActionPerformed
                    }//GEN-LAST:event_jComboBoxYScaleActionPerformed
    
    private void jPanelBaseComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanelBaseComponentResized
        Dimension panelSize=this.jPanelBase.getSize();
        //maintain the left panel at fixed X size
        this.jPanelSpectrumCommands.setLocation(0,0);
        Dimension commandSize=this.jPanelSpectrumCommands.getSize();
        this.jPanelSpectrumCommands.setSize(commandSize.width,panelSize.height);
        this.jPanelSpectrum.setLocation(commandSize.width+1,0);
        this.jPanelSpectrum.setSize(panelSize.width-commandSize.width-2,panelSize.height);
        
        
        
        
        
    }//GEN-LAST:event_jPanelBaseComponentResized
    
    private void jPanelSpectrumComponentMoved(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanelSpectrumComponentMoved
        // Add your handling code here:
    }//GEN-LAST:event_jPanelSpectrumComponentMoved
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        if (!weAreInABench){
            if (this.man!=null)
                this.man.stopCapture();
            System.exit(0);
        }
        else{
            int n = JOptionPane.showConfirmDialog(
            this,
            "This panel has been created by a bench manager. \n It should not be manually destroyed \n Are you SURE you want to continue?",
            "Alert",
            JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
            if (n==JOptionPane.YES_OPTION)
                this.dispose();
        }
        
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new JFrameSpectrum().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabelSpan;
    private javax.swing.JPanel jPanelSpectrum;
    private javax.swing.JComboBox jComboBoxAverage;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton jButtonSetZoom;
    private javax.swing.JPanel jPanelBase;
    private javax.swing.JButton jButtonSaveTrace;
    private javax.swing.JToolBar jToolBarSpectrum;
    private javax.swing.JPanel jPanelLampTrig;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JTextField jTextFieldDisplaySpan;
    private javax.swing.JComboBox jComboBoxYScale;
    private javax.swing.JButton jButtonCalibration;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanelSpectrumCommands;
    private javax.swing.JTextField jTextFieldDisplayStart;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel5;
    // End of variables declaration//GEN-END:variables
    
    public void update(Observable o, Object arg){
        //new data arrived arg is  short[] and contains the samples in sequence
        int trgLevel=10000;
        int trgPos=0;
        short[] dataS=(short[])arg;
        int i;
 /*
        if (doNotListen){
            return;}
        doNotListen=true;
  */
        //trig not found
        if (!gotTrig){
            i=0;
            while(i<dataS.length/2){
                if (dataS[2*i]>trgLevel){
                    gotTrig=true;
                    availSamples=0;
                    trgPos=i;
                    lastTrigTime=System.currentTimeMillis();
                    break;
                }
                i++;
            }
        }
        if (!gotTrig)
            return; //trig still missing
        
        //we have the trigger
        if ((ACQ_LEN-availSamples)>dataS.length/2-trgPos){
            for (i=0;i<(dataS.length/2-trgPos);i++){
                inputData[i+availSamples]=(dataS[1+2*i+2*trgPos]);
            }
            availSamples+=(dataS.length/2-trgPos);
        }
        else{
            for (i=0;i<ACQ_LEN-availSamples-1;i++){
                inputData[i+availSamples]=(dataS[1+2*i+2*trgPos]);
            }
            availSamples=0;
            gotTrig=false;
            computeSamples(inputData);
            this.jPanelSpectrum.repaint();
            doNotListen=false;
        }
 /*
  }
    catch(Throwable t){
        t.printStackTrace();
    }
  */
    }
    
    private boolean computeSamples(int[] dataS){
        
        
        int base=(int)(0.95*h);
        int space=(int)(0.9*h);
        double scale=space/32700.0;
        long sumAvgValue=0;
        int avgValue,i;
        //compute the average
        for (i=0;i<ACQ_LEN;i++)
            sumAvgValue+=dataS[i];
        avgValue=(int)(sumAvgValue/ACQ_LEN);
        for (i=0;i<ACQ_LEN;i++)
            dataS[i]=Math.abs(dataS[i]-avgValue);
        
        
        //compute the envelope
        int W=5;
        for (int x = W; x < ACQ_LEN-W; x++) {
            
            int m=dataS[x-W];
            for (int j=x-W;j<x+W;j++){
                if (dataS[j]>m)
                    m=dataS[j];
            }
            yChannel1[x]=base-(int)(scale*m);
        }
        return true;
        
        
        
        
        
    }
    
    public void setInputOffset(short newOffsetCh1, short newOffsetCh2) {
    }
    
    public void useInputOffset(boolean use) {
    }
    
    class SpectrumScreen extends JPanel {
        
        public SpectrumScreen() {
            setBackground(new Color(20, 20, 20));
        }
        public void update(Graphics g) {
            // Paint directly to avoid clearing the screen.
            paint(g);
        }
        
        public void paint(Graphics g) {
            int i=0;
            double expX=1;
            super.paint(g);
            Dimension d = getSize();
            int wn = d.width;
            int hn = d.height;
            if (wn!=w | hn!=h | recompute){
                //the screen size has changed throw the  data
                recompute=false;
                w=wn;
                h=hn;
                xScreen=new int[ACQ_LEN];
                for (int j=0;j<(xStop-xStart);j++)
                    xScreen[j]=(int)(w*j/(xStop-xStart));
            }
            Graphics2D g2 = (Graphics2D) g;
            g2.setBackground(getBackground());
            g2.clearRect(0, 0, w, h);
            doGrid(g2); //    //draw the grid
            //plot the traces
            g2.setColor(Color.yellow);
            
            
            for (i = 1; i < (xStop-xStart); i++) {
                g2.drawLine(xScreen[(i-1)], yChannel1[xStart+i-1],
                xScreen[i],yChannel1[xStart+i]);
            }
            doNotListen=false;
        }
        
        private void doMessage(Graphics2D g2){
            g2.drawString("ciao",10,10);
        }
        private void doGrid(Graphics2D g2){
            int i=0;
            //do the main grid
            int base=(int)(0.95*h);
            int space=(int)(0.9*h);
            
            
            //do the vertical grid
            g2.setColor(Color.lightGray);
            for (i=0;i<=3;i++)
                g2.drawLine(0,(int)(base-space*i/3.0),w, (int)(base-space*i/3.0));
            //do the horizontal grid
            float xsc=(float)((20000.0/22100.0)*w/10.0);
            for (i=1;i<=10;i++)
                g2.drawLine((int)(xsc*i),base,(int)(xsc*i),base-space);
            
          /*
           
            //do the external box
            g2.setColor(Color.green);
            g2.drawLine(0,0,w-1,0);
            g2.drawLine(0,0,0,h-1);
            g2.drawLine(w-1,h-1,w-1,0);
            g2.drawLine(w-1,h-1,0,h-1);
            //do the axes
            g2.drawLine(0,h/2,w,h/2);
            g2.drawLine(w/2,0,w/2,h);
            //do the ticks
            int xMin=w/2-w/80;
            int xMax=w/2+w/80;
            for (i=1;i<40;i++)
                g2.drawLine(xMin,i*h/40,xMax,i*h/40);
            int yMin=h/2-h/72;
            int yMax=h/2+h/72;
            for (i=1;i<50;i++)
                g2.drawLine(i*w/50,yMin,i*w/50,yMax);
           */
        }
    } // End class ScopeScreen
    
    class ScopeMonitor extends TimerTask{
        //this class is used to update the status and trig lamps
        
        public ScopeMonitor() {
            //System.out.println("Timer created");
        }
        public void run() {
            if ((System.currentTimeMillis()-lastTrigTime)>3000){
                //it a long time without trig
                ((SignalPanel)jPanelLampTrig).setState(SignalPanel.sStateRed);
            }
            else if ((System.currentTimeMillis()-lastTrigTime)>1500){
                ((SignalPanel)jPanelLampTrig).setState(SignalPanel.sStateGrey);
            }
            else
                ((SignalPanel)jPanelLampTrig).setState(SignalPanel.sStateGreen);
            
            
        }//method run
    }//class monitor
    
    
}
