/*
 *  JFrameDebug.java
 *  Created on January 29, 2002, 1:31 PM
 *  Version 1beta0
 *  @author  Marco Parvis
 */

/*
    Questo e' JFrameDebug una parte di Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
    This is JFrameDebug part of the Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
 */

/*
    Questo  programma e'  software  libero; e'  lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come e' pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.
 
    Questo programma  e' distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILITA'  o di  APPLICABILITA' PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.
 
    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne puo'
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA
 
    L'autore puo' essere contattato a parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 */

/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA
 
    The author can be contacted at parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 
 */


/*
 * This panel provides a simple text window for debug purposes
 */

package JavaScope;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import javax.sound.sampled.*;
import java.io.*;
import java.nio.*;



/**
 *
 * @author  admsermis
 */
public class JFrameDebug extends javax.swing.JFrame implements VirtualPanel{
    
    
    private boolean weAreInABench=false;
    private String panelIdString;
    private boolean flashOn=false;
    
    
    public String getSettings(){
        
        int x=this.getLocation().x;
        int y=this.getLocation().y;
        int w=this.getSize().width;
        int h=this.getSize().height;
        
        String s=panelIdString+"|Position="+String.valueOf(x)+","+String.valueOf(y)+"|Size="+String.valueOf(w)+","+String.valueOf(h)+"|";
        return s;
    }
    public void applySettings(String settings){
        boolean hasSize=false;
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        
        StringTokenizer tokens=new StringTokenizer(settings,"|");
        while (tokens.hasMoreTokens()){
            String token=tokens.nextToken();
            //browse through recognized tokens
            if (token.indexOf("Position=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<1) x=1;
                    if (x>screenSize.width-10) x=screenSize.width-10;
                    if (y<1) y=1;
                    if (y>screenSize.height-10) y=screenSize.height-10;
                    
                    this.setLocation(x,y);
                }catch (Throwable t){}
                
            }else if (token.indexOf("Size=")>=0){
                hasSize=true;
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<10) x=10;
                    if (x>screenSize.width-20) x=screenSize.width-20;
                    if (y<10) y=10;
                    if (y>screenSize.height-20) y=screenSize.height-20;
                    this.setSize(x,y);
                }catch (Throwable t){}
            }
        }
        if (!hasSize)
            this.setSize(300,400);
        
    }
    private String[] getValues(String s){
        int peq=s.indexOf("=");
        if (peq>0){
            StringTokenizer ss=new StringTokenizer(s.substring(peq+1),",");
            if (ss.countTokens()>0){
                String[] vl=new String[ss.countTokens()];
                for (int i=0;i<vl.length;i++)
                    vl[i]=ss.nextToken();
                return vl;
            }else
                return new String[0];
            
        }else
            return new String[0];
    }
    public void useOutputCalibration(boolean use){
    }
    public void useInputCalibration(boolean use){
    }
    public void setOutputCalibration(double newCalCh1,double newCalCh2){
    }
    public void setInputCalibration(double newCalCh1,double newCalCh2){
    }
    
    public void setOutputManager(OutputManager im){
    }
    public void setInputManager(InputManager im){
    }
    public void setInputOffset(short newOffsetCh1, short newOffsetCh2) {
    }
    
    public void useInputOffset(boolean use) {
    }
    
    public void setBenchComponent(boolean bc){
        weAreInABench=bc;
        if (bc)
            this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        else
            this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        
    }
    public void setIdString(String s){
        this.panelIdString=s;
        this.setTitle(s);
    }
    public String getIdString(){
        return this.panelIdString;
    }
    public void update(java.util.Observable observable, java.lang.Object obj) {
        
        short[] dataS=(short[])obj;
        
    }
    private AudioFormat getFormat() {
        AudioFormat.Encoding encoding = AudioFormat.Encoding.PCM_SIGNED;
        int channels=2;
        int sampleSize=16;
        float rate=1000; //44100;
        boolean bigEndian;
        ByteOrder bo=ByteOrder.nativeOrder();
        if (bo==ByteOrder.BIG_ENDIAN)
            bigEndian=true;
        else
            bigEndian=false;
        return new AudioFormat(encoding,
        rate,
        sampleSize,
        channels,
        (sampleSize/8)*channels,
        rate,
        bigEndian);
    }//of getFormat
    
    private void testAudioSystem(){
        this.jTextAreaDebug.append("Querying the Java AudioSystem...... ");
        Line.Info li=new Line.Info(TargetDataLine.class);
        Line.Info[] lis=AudioSystem.getTargetLineInfo(li);
        this.jTextAreaDebug.append("the system reports that: \n\n");
        
        if (lis.length>0){
            if(lis.length==1)
                this.jTextAreaDebug.append("There is one target line\n");
            else
                this.jTextAreaDebug.append("There are "+Integer.toString(lis.length)+" Target line(s)\n");
            
            for (int i=0;i<lis.length;i++){
                DataLine.Info dli=(DataLine.Info)lis[i];
                AudioFormat[] af=dli.getFormats();
                this.jTextAreaDebug.append("\nTARGET LINE #"+Integer.toString(i)+" has "+Integer.toString(af.length)+" modes\n");
                for (int j=0;j<af.length;j++)
                    this.jTextAreaDebug.append(af[j].toString()+"\n");
            }
        }else
            this.jTextAreaDebug.append("There are NO TARGET LINES !!\n");
        
        
        this.jTextAreaDebug.append("\n\n");
        
        li=new Line.Info(SourceDataLine.class);
        lis=AudioSystem.getSourceLineInfo(li);
        if (lis.length>0){
            if (lis.length==1)
                this.jTextAreaDebug.append("There is one source line\n");
            else
                this.jTextAreaDebug.append("There are "+Integer.toString(lis.length)+" Source line(s)\n");
            for (int i=0;i<lis.length;i++){
                DataLine.Info dli=(DataLine.Info)lis[i];
                AudioFormat[] af=dli.getFormats();
                this.jTextAreaDebug.append("\nSOURCE LINE #"+Integer.toString(i)+" has "+Integer.toString(af.length)+" modes\n");
                for (int j=0;j<af.length;j++){
                    this.jTextAreaDebug.append(af[j].toString()+"\n");
                }
            }
        }
        else
            this.jTextAreaDebug.append("There are NO SOURCE LINES !!\n");
        
/*
        AudioFormat format = getFormat(); //get format 44.1kHz, 16 bit stereo
        DataLine.Info info = new DataLine.Info(SourceDataLine.class,
        format);
        if (!AudioSystem.isLineSupported(info)) {
            System.out.println("Not supported line");
        }else{
            System.out.println("Line "+info.toString()+" is supported");
 
 
 
            try {
                SourceDataLine line = (SourceDataLine) AudioSystem.getLine(info);
                line.open(format, 20000);
                System.out.println("Line "+info.toString()+" has been opened");
                line.close();
            }
            catch (LineUnavailableException ex) {
                System.out.println("Cannot open line " + ex);
            }
        }
 */
        
        
        
        
        
        
    }
    
    /** Creates new form JFrameDebug */
    public JFrameDebug() {
        initComponents();
        this.testAudioSystem();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jScrollPaneDebug = new javax.swing.JScrollPane();
        jTextAreaDebug = new javax.swing.JTextArea();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jScrollPaneDebug.setViewportView(jTextAreaDebug);

        getContentPane().add(jScrollPaneDebug, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        JFrameDebug fd=new JFrameDebug();
        fd.setSize(400,500);
        fd.show();
        
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPaneDebug;
    private javax.swing.JTextArea jTextAreaDebug;
    // End of variables declaration//GEN-END:variables
    
}
