/*
 *  JFrameFreq.java
 *  Created on January 29, 2002, 1:31 PM
 *  Version 1beta0
 *  @author  Marco Parvis
 */


/*
    Questo e' JFrameDmm una parte di Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
    This is JFrameDmm part of the Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
 */

/*
    Questo  programma e'  software  libero; e'  lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come e' pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.
 
    Questo programma  e' distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILITA'  o di  APPLICABILITA' PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.
 
    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne puo'
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA
 
    L'autore puo' essere contattato a parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 */

/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA
 
    The author can be contacted at parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 
 */



/*
 * This panel implements a Counter
 */

package JavaScope;

import java.awt.*;
//import java.awt.event.*;
//import java.awt.geom.Line2D;
import javax.swing.*;
//import javax.swing.event.*;
//import javax.swing.border.*;
import java.util.*;
//import java.util.Enumeration;
//import java.io.*;
//import javax.sound.sampled.*;
//import java.awt.font.*;
import java.text.*;
//
//import java.nio.*;




public class JFrameFreq extends javax.swing.JFrame implements VirtualPanel{ //implements Observer{
    
    
    private final int TRIG_CH1=1;
    private final int TRIG_CH2=2;
    //  private final int TRIG_FREE=3;
    //  private final int TRIG_AUTO=0;
    //  private final int TRIG_NORM=1;
    private final int SLOPE_UP=0;
    private final int SLOPE_DOWN=1;
    private final int ACTIVE=1;
    private final int NOT_ACTIVE=0;
    
    private final int FREQ_MODE=1;
    private final int PERIOD_MODE=2;
    private final int AUTO_MODE=3;
    private final int ONE_TWO_MODE=4;
    
    
    private final int HIST=1000; //used for trigger purposes
    //short time 0.1s 1s 5s 10s
    private final int[] INT_TIMES={0,2205, 4410, 8820, 22050,44100, 88200, 220500};
    //                               50ms 100ms 200ms .5s   1s       2s     5s
    
    private int actIntTime=0;
    
    
    private final int[] SKIP_SAMPLES={20,      10,    4,     2,    1};
    //                                2.2kHz  4.4kHz 11kHz 22kHz 44kHz
    private int actSkip=1;
    
    private final int PRE_PRE_SEARCH=0,PRE_SEARCH=1,FIRST_SEARCH=2,SECOND_SEARCH=3;
    private final int PRE_SECOND_SEARCH=4;
    private int lastGoodTransition=0,lastSearchPoint=0,searchPhase=PRE_SEARCH;
    private int trigStart,trigEnd,cycles;
    private boolean weAreInABench=false;
    private String panelIdString;
    
    private boolean flashOn=false;
    InputManager man;
    private boolean useCalibrationFactor=false;
    private double calFactorVoltAtBitCh1=1;
    private double calFactorVoltAtBitCh2=1;
    
    private int actualMode=FREQ_MODE;
    private int actualChMode=TRIG_CH1;
    private short actualTrigLevel1=0;
    private int actualTrigSlope1=SLOPE_UP;
    private short actualTrigLevel2=0;
    private int actualTrigSlope2=SLOPE_UP;
    
    short trigThPlus=0,trigThMinus=0;
    
    
    
    
    private final int samplingFreq=44100;
    private final int lineFreq=50;
    
    private boolean measStarted=false;
    private long saveIntermediate;
    private int gotSamples;
    private int actualChannel=0;
    private int actualNumberOfSamples=0;
    
    private java.util.Timer timerMonitor;
    private FreqMonitor freqMonitor;
    
    
    
    /** Creates new form JFrameDmm */
    public String getSettings(){
  
        int x=this.getLocation().x;
        int y=this.getLocation().y;
        int w=this.getSize().width;
        int h=this.getSize().height;
        
        String s=panelIdString+"|Position="+String.valueOf(x)+","+String.valueOf(y)+"|Size="+String.valueOf(w)+","+String.valueOf(h)+"|";
        if (this.useCalibrationFactor)
            s=s+"UseInputCal=1|";
        else
            s=s+"UseInputCal=0|";
        s=s+"InputCalFactors="+String.valueOf(this.calFactorVoltAtBitCh1)+","+String.valueOf(this.calFactorVoltAtBitCh2);
        return s;
    }
    public void applySettings(String settings){
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        
        StringTokenizer tokens=new StringTokenizer(settings,"|");
        while (tokens.hasMoreTokens()){
            String token=tokens.nextToken();
            //browse through recognized tokens
            if (token.indexOf("Position=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<1) x=1;
                    if (x>screenSize.width-10) x=screenSize.width-10;
                    if (y<1) y=1;
                    if (y>screenSize.height-10) y=screenSize.height-10;
                    
                    this.setLocation(x,y);
                }catch (Throwable t){}
                
            }else if (token.indexOf("Size=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<10) x=10;
                    if (x>screenSize.width-20) x=screenSize.width-20;
                    if (y<10) y=10;
                    if (y>screenSize.height-20) y=screenSize.height-20;
                    this.setSize(x,y);
                }catch (Throwable t){}
            }else if (token.indexOf("UseInputCal=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    if (x!=0)
                        this.useCalibrationFactor=true;
                    else
                        this.useCalibrationFactor=false;
                }catch (Throwable t){}
            }else if (token.indexOf("InputCalFactors=")>=0){
                String[] p=getValues(token);
                try{
                    double x=new Double(p[0]).doubleValue();
                    double y=new  Double(p[1]).doubleValue();
                    this.calFactorVoltAtBitCh1=x;
                    this.calFactorVoltAtBitCh2=y;
                }catch (Throwable t){}
            }
        }
    }
    private String[] getValues(String s){
        int peq=s.indexOf("=");
        if (peq>0){
            StringTokenizer ss=new StringTokenizer(s.substring(peq+1),",");
            if (ss.countTokens()>0){
                String[] vl=new String[ss.countTokens()];
                for (int i=0;i<vl.length;i++)
                    vl[i]=ss.nextToken();
                return vl;
            }else
                return new String[0];
            
        }else
            return new String[0];
    }
    public void useOutputCalibration(boolean use){
    }
    public void useInputCalibration(boolean use){
        this.useCalibrationFactor=use;
    }
    public void setOutputCalibration(double newCalCh1,double newCalCh2){
    }
    public void setInputCalibration(double newCalCh1,double newCalCh2){
        this.calFactorVoltAtBitCh1=newCalCh1;
        this.calFactorVoltAtBitCh2=newCalCh2;
    }
    
    public void setOutputManager(OutputManager im){
    }
    public void setInputManager(InputManager im){
        this.man=im;
        man.addObserver(this);
    }
    
    public void setBenchComponent(boolean bc){
        weAreInABench=bc;
        if (bc)
            this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        else
            this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        
    }
    public void setIdString(String s){
        this.panelIdString=s;
        this.setTitle(s);
    }
    public String getIdString(){
        return this.panelIdString;
    }
    
    
    public JFrameFreq(InputManager im) {
        this.man=im;
        initComponents();
        man.addObserver(this);
        actualMode=FREQ_MODE;
        this.jToggleButtonCh1.setSelected(true);
        actualNumberOfSamples=samplingFreq/lineFreq; //one plc
        weAreInABench=false;
        freqMonitor=new FreqMonitor();
        timerMonitor=new java.util.Timer();
        timerMonitor.scheduleAtFixedRate(freqMonitor,250,250);
    }
    public JFrameFreq() {
        initComponents();
        actualMode=FREQ_MODE;
        this.jToggleButtonCh1.setSelected(true);
        actualNumberOfSamples=samplingFreq/lineFreq; //one plc
        freqMonitor=new FreqMonitor();
        timerMonitor=new java.util.Timer();
        timerMonitor.scheduleAtFixedRate(freqMonitor,250,250);
        ((SignalPanel)this.jPanelLamp).setCentered(true);
        weAreInABench=false;
        
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroupMode = new javax.swing.ButtonGroup();
        buttonGroupChannels = new javax.swing.ButtonGroup();
        buttonGroupSlope1 = new javax.swing.ButtonGroup();
        buttonGroupSlope2 = new javax.swing.ButtonGroup();
        jTextFieldResult = new javax.swing.JTextField();
        jPanelLamp = new SignalPanel();
        jPanelMode = new javax.swing.JPanel();
        jToggleButton1to2 = new javax.swing.JToggleButton();
        jToggleButtonFreq = new javax.swing.JToggleButton();
        jToggleButtonPeriod = new javax.swing.JToggleButton();
        jToggleButtonAuto = new javax.swing.JToggleButton();
        jToggleButtonCh1 = new javax.swing.JToggleButton();
        jToggleButtonCh2 = new javax.swing.JToggleButton();
        jLabel1 = new javax.swing.JLabel();
        jPanelTrigCh1 = new javax.swing.JPanel();
        jToggleButtonSlopeUp1 = new javax.swing.JToggleButton();
        jToggleButtonSlopeDown1 = new javax.swing.JToggleButton();
        jSliderLevel1 = new javax.swing.JSlider();
        jLabelLevel1 = new javax.swing.JLabel();
        jPanelTrigCh2 = new javax.swing.JPanel();
        jToggleButtonSlopeUp2 = new javax.swing.JToggleButton();
        jToggleButtonSlopeDown2 = new javax.swing.JToggleButton();
        jSliderLevel2 = new javax.swing.JSlider();
        jLabelLevel2 = new javax.swing.JLabel();
        jPanelGate = new javax.swing.JPanel();
        jLabelGate = new javax.swing.JLabel();
        jSliderGate = new javax.swing.JSlider();
        jPanelTimeBase = new javax.swing.JPanel();
        jSliderTimeBase = new javax.swing.JSlider();
        jLabelTimeBase = new javax.swing.JLabel();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jTextFieldResult.setBackground(java.awt.Color.black);
        jTextFieldResult.setEditable(false);
        jTextFieldResult.setFont(new java.awt.Font("Dialog", 1, 18));
        jTextFieldResult.setForeground(java.awt.Color.green);
        jTextFieldResult.setText("000000");
        jTextFieldResult.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        jTextFieldResult.setMargin(new java.awt.Insets(0, 0, 5, 0));
        jTextFieldResult.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldResultActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 2;
        gridBagConstraints.ipady = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(jTextFieldResult, gridBagConstraints);

        jPanelLamp.setLayout(new java.awt.GridBagLayout());

        jPanelLamp.setBackground(java.awt.Color.black);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 10;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(jPanelLamp, gridBagConstraints);

        jPanelMode.setLayout(new java.awt.GridBagLayout());

        jPanelMode.setBorder(new javax.swing.border.TitledBorder("Mode"));
        jToggleButton1to2.setToolTipText("1 to 2");
        buttonGroupMode.add(jToggleButton1to2);
        jToggleButton1to2.setLabel("12");
        jToggleButton1to2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton1to2.setMaximumSize(new java.awt.Dimension(32, 32));
        jToggleButton1to2.setMinimumSize(new java.awt.Dimension(32, 32));
        jToggleButton1to2.setPreferredSize(new java.awt.Dimension(32, 32));
        jToggleButton1to2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1to2ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        jPanelMode.add(jToggleButton1to2, gridBagConstraints);

        jToggleButtonFreq.setText("F");
        jToggleButtonFreq.setToolTipText("Frequency");
        buttonGroupMode.add(jToggleButtonFreq);
        jToggleButtonFreq.setMargin(new java.awt.Insets(2, 7, 2, 7));
        jToggleButtonFreq.setMaximumSize(new java.awt.Dimension(32, 32));
        jToggleButtonFreq.setMinimumSize(new java.awt.Dimension(32, 32));
        jToggleButtonFreq.setPreferredSize(new java.awt.Dimension(32, 32));
        jToggleButtonFreq.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonFreqActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanelMode.add(jToggleButtonFreq, gridBagConstraints);

        jToggleButtonPeriod.setText("P");
        jToggleButtonPeriod.setToolTipText("Period");
        buttonGroupMode.add(jToggleButtonPeriod);
        jToggleButtonPeriod.setMargin(new java.awt.Insets(2, 7, 2, 7));
        jToggleButtonPeriod.setMaximumSize(new java.awt.Dimension(32, 32));
        jToggleButtonPeriod.setMinimumSize(new java.awt.Dimension(32, 32));
        jToggleButtonPeriod.setPreferredSize(new java.awt.Dimension(32, 32));
        jToggleButtonPeriod.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonPeriodActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanelMode.add(jToggleButtonPeriod, gridBagConstraints);

        jToggleButtonAuto.setText("A");
        jToggleButtonAuto.setToolTipText("AutoMode");
        buttonGroupMode.add(jToggleButtonAuto);
        jToggleButtonAuto.setMargin(new java.awt.Insets(2, 7, 2, 7));
        jToggleButtonAuto.setMaximumSize(new java.awt.Dimension(32, 32));
        jToggleButtonAuto.setMinimumSize(new java.awt.Dimension(32, 32));
        jToggleButtonAuto.setPreferredSize(new java.awt.Dimension(32, 32));
        jToggleButtonAuto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonAutoActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanelMode.add(jToggleButtonAuto, gridBagConstraints);

        jToggleButtonCh1.setText("1");
        buttonGroupChannels.add(jToggleButtonCh1);
        jToggleButtonCh1.setMargin(new java.awt.Insets(2, 7, 2, 7));
        jToggleButtonCh1.setMaximumSize(new java.awt.Dimension(30, 20));
        jToggleButtonCh1.setMinimumSize(new java.awt.Dimension(30, 20));
        jToggleButtonCh1.setPreferredSize(new java.awt.Dimension(30, 20));
        jToggleButtonCh1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonCh1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelMode.add(jToggleButtonCh1, gridBagConstraints);

        jToggleButtonCh2.setText("2");
        buttonGroupChannels.add(jToggleButtonCh2);
        jToggleButtonCh2.setMargin(new java.awt.Insets(2, 7, 2, 7));
        jToggleButtonCh2.setMaximumSize(new java.awt.Dimension(30, 20));
        jToggleButtonCh2.setMinimumSize(new java.awt.Dimension(30, 20));
        jToggleButtonCh2.setPreferredSize(new java.awt.Dimension(30, 20));
        jToggleButtonCh2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonCh2ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelMode.add(jToggleButtonCh2, gridBagConstraints);

        jLabel1.setText("CH");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanelMode.add(jLabel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        getContentPane().add(jPanelMode, gridBagConstraints);

        jPanelTrigCh1.setLayout(new java.awt.GridBagLayout());

        jPanelTrigCh1.setBorder(new javax.swing.border.TitledBorder("Input#1"));
        jToggleButtonSlopeUp1.setText("u1");
        buttonGroupSlope1.add(jToggleButtonSlopeUp1);
        jToggleButtonSlopeUp1.setMargin(new java.awt.Insets(2, 7, 2, 7));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanelTrigCh1.add(jToggleButtonSlopeUp1, gridBagConstraints);

        jToggleButtonSlopeDown1.setText("d1");
        buttonGroupSlope1.add(jToggleButtonSlopeDown1);
        jToggleButtonSlopeDown1.setMargin(new java.awt.Insets(2, 7, 2, 7));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanelTrigCh1.add(jToggleButtonSlopeDown1, gridBagConstraints);

        jSliderLevel1.setMajorTickSpacing(50);
        jSliderLevel1.setMaximum(99);
        jSliderLevel1.setMinimum(-99);
        jSliderLevel1.setOrientation(javax.swing.JSlider.VERTICAL);
        jSliderLevel1.setPreferredSize(new java.awt.Dimension(30, 70));
        jSliderLevel1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderLevel1StateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelTrigCh1.add(jSliderLevel1, gridBagConstraints);

        jLabelLevel1.setText("+00%");
        jLabelLevel1.setMaximumSize(new java.awt.Dimension(35, 16));
        jLabelLevel1.setMinimumSize(new java.awt.Dimension(35, 16));
        jLabelLevel1.setPreferredSize(new java.awt.Dimension(35, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        jPanelTrigCh1.add(jLabelLevel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        getContentPane().add(jPanelTrigCh1, gridBagConstraints);

        jPanelTrigCh2.setLayout(new java.awt.GridBagLayout());

        jPanelTrigCh2.setBorder(new javax.swing.border.TitledBorder("Input#2"));
        jToggleButtonSlopeUp2.setText("u2");
        buttonGroupSlope2.add(jToggleButtonSlopeUp2);
        jToggleButtonSlopeUp2.setMargin(new java.awt.Insets(2, 7, 2, 7));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanelTrigCh2.add(jToggleButtonSlopeUp2, gridBagConstraints);

        jToggleButtonSlopeDown2.setText("d2");
        buttonGroupSlope2.add(jToggleButtonSlopeDown2);
        jToggleButtonSlopeDown2.setMargin(new java.awt.Insets(2, 7, 2, 7));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 0);
        jPanelTrigCh2.add(jToggleButtonSlopeDown2, gridBagConstraints);

        jSliderLevel2.setMajorTickSpacing(50);
        jSliderLevel2.setMaximum(99);
        jSliderLevel2.setMinimum(-99);
        jSliderLevel2.setOrientation(javax.swing.JSlider.VERTICAL);
        jSliderLevel2.setPreferredSize(new java.awt.Dimension(30, 70));
        jSliderLevel2.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderLevel2StateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelTrigCh2.add(jSliderLevel2, gridBagConstraints);

        jLabelLevel2.setText("+00%");
        jLabelLevel2.setMaximumSize(new java.awt.Dimension(35, 16));
        jLabelLevel2.setMinimumSize(new java.awt.Dimension(35, 16));
        jLabelLevel2.setPreferredSize(new java.awt.Dimension(35, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        jPanelTrigCh2.add(jLabelLevel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        getContentPane().add(jPanelTrigCh2, gridBagConstraints);

        jPanelGate.setLayout(new java.awt.GridBagLayout());

        jPanelGate.setBorder(new javax.swing.border.TitledBorder("Gate"));
        jLabelGate.setText("200ms");
        jLabelGate.setMaximumSize(new java.awt.Dimension(50, 16));
        jLabelGate.setMinimumSize(new java.awt.Dimension(50, 16));
        jLabelGate.setPreferredSize(new java.awt.Dimension(50, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanelGate.add(jLabelGate, gridBagConstraints);

        jSliderGate.setMajorTickSpacing(1);
        jSliderGate.setMaximum(7);
        jSliderGate.setValue(0);
        jSliderGate.setMaximumSize(new java.awt.Dimension(50, 16));
        jSliderGate.setMinimumSize(new java.awt.Dimension(50, 16));
        jSliderGate.setPreferredSize(new java.awt.Dimension(50, 16));
        jSliderGate.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderGateStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanelGate.add(jSliderGate, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jPanelGate, gridBagConstraints);

        jPanelTimeBase.setLayout(new java.awt.GridBagLayout());

        jPanelTimeBase.setBorder(new javax.swing.border.TitledBorder("Time Base"));
        jPanelTimeBase.setMinimumSize(new java.awt.Dimension(110, 41));
        jPanelTimeBase.setPreferredSize(new java.awt.Dimension(110, 41));
        jSliderTimeBase.setMajorTickSpacing(1);
        jSliderTimeBase.setMaximum(4);
        jSliderTimeBase.setMaximumSize(new java.awt.Dimension(50, 16));
        jSliderTimeBase.setMinimumSize(new java.awt.Dimension(50, 16));
        jSliderTimeBase.setPreferredSize(new java.awt.Dimension(50, 16));
        jSliderTimeBase.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderTimeBaseStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanelTimeBase.add(jSliderTimeBase, gridBagConstraints);

        jLabelTimeBase.setText("44.1kHz");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanelTimeBase.add(jLabelTimeBase, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jPanelTimeBase, gridBagConstraints);

        pack();
    }//GEN-END:initComponents
    
    private void jSliderTimeBaseStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderTimeBaseStateChanged
        
        int selected=this.jSliderTimeBase.getValue();
        actSkip=SKIP_SAMPLES[selected];
        this.jLabelTimeBase.setText(timeBaseAsString(selected));
    }//GEN-LAST:event_jSliderTimeBaseStateChanged
    
    private void jSliderGateStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderGateStateChanged
        int selected=this.jSliderGate.getValue();
        actIntTime=INT_TIMES[selected];
        this.jLabelGate.setText(gateTimeAsString(selected));
    }//GEN-LAST:event_jSliderGateStateChanged
    
    private void jSliderLevel2StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderLevel2StateChanged
        DecimalFormat df2 = (DecimalFormat)NumberFormat.getInstance();
        df2.applyPattern("+00;-00");
        
        this.jLabelLevel2.setText(df2.format(this.jSliderLevel2.getValue())+"%");
        actualTrigLevel2=(short)(30000*this.jSliderLevel2.getValue()/100);
    }//GEN-LAST:event_jSliderLevel2StateChanged
    
    private void jSliderLevel1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderLevel1StateChanged
        DecimalFormat df2 = (DecimalFormat)NumberFormat.getInstance();
        df2.applyPattern("+00;-00");
        
        this.jLabelLevel1.setText(df2.format(this.jSliderLevel1.getValue())+"%");
        actualTrigLevel1=(short)(30000*this.jSliderLevel1.getValue()/100);
    }//GEN-LAST:event_jSliderLevel1StateChanged
    
    private void jToggleButton1to2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1to2ActionPerformed
        // Add your handling code here:
        actualMode=ONE_TWO_MODE;
        measStarted=false;
    }//GEN-LAST:event_jToggleButton1to2ActionPerformed
    
    private void jToggleButtonAutoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonAutoActionPerformed
        // Add your handling code here:
        actualMode=AUTO_MODE;
        measStarted=false;
    }//GEN-LAST:event_jToggleButtonAutoActionPerformed
    
    private void jToggleButtonPeriodActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonPeriodActionPerformed
        actualMode=PERIOD_MODE;
        measStarted=false;
    }//GEN-LAST:event_jToggleButtonPeriodActionPerformed
    
    private void jTextFieldResultActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldResultActionPerformed
                                                    }//GEN-LAST:event_jTextFieldResultActionPerformed
    
                    private void jToggleButtonFreqActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonFreqActionPerformed
                        actualMode=FREQ_MODE;
                        measStarted=false;
                    }//GEN-LAST:event_jToggleButtonFreqActionPerformed
                    
    private void jToggleButtonCh2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonCh2ActionPerformed
        actualChannel=1;
        measStarted=false;
        setEnableTrig(false,true);
        
    }//GEN-LAST:event_jToggleButtonCh2ActionPerformed
    
    private void jToggleButtonCh1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonCh1ActionPerformed
        actualChannel=0;
        setEnableTrig(true,false);
        measStarted=false;
    }//GEN-LAST:event_jToggleButtonCh1ActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        if (!weAreInABench){
            if (this.man!=null)
                this.man.stopCapture();
            System.exit(0);
        }
        else{
            int n = JOptionPane.showConfirmDialog(
            this,
            "This panel has been created by a bench manager. \n It should not be manually destroyed \n Are you SURE you want to continue?",
            "Alert",
            JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
            if (n==JOptionPane.YES_OPTION)
                this.dispose();
        }
        
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new JFrameFreq().show();
    }
    private void setEnableTrig(boolean t1,boolean t2){
        this.jToggleButtonSlopeDown1.setEnabled(t1);
        this.jToggleButtonSlopeUp1.setEnabled(t1);
        this.jSliderLevel1.setEnabled(t1);
        this.jToggleButtonSlopeDown2.setEnabled(t2);
        this.jToggleButtonSlopeUp2.setEnabled(t2);
        this.jSliderLevel2.setEnabled(t2);
        
    }
    public void update(java.util.Observable observable, java.lang.Object obj) {
        short[] dataS=(short[])obj;
        long r=0;
        int availSamples;
        double rd,actualPeak=-1,actualNegativePeak=1;
        //this is a new measurement
        ((SignalPanel)this.jPanelLamp).setState(SignalPanel.sStateGrey);
        if (!measStarted){
            measStarted=true;
            lastSearchPoint=(int)(1000*Math.random())*2;
            lastGoodTransition=-1;
            searchPhase=PRE_PRE_SEARCH;
            cycles=0;
            System.out.print("\nstarting new meas from"+lastSearchPoint);
            
        }
        int channel=0,direction=SLOPE_UP;
        boolean exausted=false;
        while (!exausted)
            switch (searchPhase){
                case PRE_PRE_SEARCH:
                    if (getPrePrePosition(dataS,channel,direction)){
                        searchPhase=PRE_SEARCH;
                        System.out.print("\nprepre got at "+lastSearchPoint);
                        
                    }else
                        return;
                case PRE_SEARCH:
                    if (getPrePosition(dataS,channel,direction)){
                        searchPhase=FIRST_SEARCH;
                        System.out.print("\npre got at "+lastSearchPoint);
                        
                    }else
                        return;
                case FIRST_SEARCH:
                    if (getTrigPosition(dataS,channel,direction)){
                        searchPhase=PRE_SECOND_SEARCH;
                        trigStart=lastSearchPoint;
                        System.out.print("\nfirst got at "+lastSearchPoint);
                        
                    }
                    else
                        return;
                case PRE_SECOND_SEARCH:
                    if (getPrePosition(dataS,channel,direction)){
                        searchPhase=SECOND_SEARCH;
                        System.out.print("\npresecond got at "+lastSearchPoint);
                        
                    }else
                        return;
                case SECOND_SEARCH:
                    if (getTrigPosition(dataS,channel,direction)){
                        //is the interval over ?
                        if (actIntTime!=0)
                            if ((lastSearchPoint-trigStart)>actIntTime){
                                cycles+=1;
                                searchPhase=PRE_SEARCH;
                            }else{
                                measStarted=false;
                                cycles=1;
                                trigEnd=lastSearchPoint;
                                System.out.print("\nsecond at "+lastSearchPoint);
                                updatePanel();
                            }
                    }
                    else
                        return;
                default:
            }
    }
    
    
    
    
    private void updatePanel(){
        DecimalFormat df2 =
        (DecimalFormat)NumberFormat.getInstance();
        df2.applyPattern("#00.000");
        String label;
    
        double rd=2*samplingFreq/(trigEnd-trigStart)*cycles;
        //        rd=(double)findFreq(dataS);
        switch (actualMode){
            case PERIOD_MODE:
                
                df2.applyPattern("00000.000");
                if (rd!=0){
                    double period=1/rd;
                    double m=Math.log(period)/Math.log(10);
                    if (m<-3.0)
                        label=new String(df2.format(period*1e6)+" us");
                    else
                        label=new String(df2.format(period*1e3)+" ms");
                }else
                    label=new String("????");
                
                this.jTextFieldResult.setText(label);
                break;
            case FREQ_MODE:
                df2.applyPattern("00000.000");
                label=new String(df2.format(rd));
                this.jTextFieldResult.setText(label+" Hz");
                break;
            case AUTO_MODE:
                df2.applyPattern("00000.000");
                label=new String(df2.format(rd));
                this.jTextFieldResult.setText(label+" Hz");
                break;
            case ONE_TWO_MODE:
                df2.applyPattern("00000.000");
                label=new String(df2.format(rd));
                this.jTextFieldResult.setText(label+" Hz");
                break;
            default:
        }
        ((SignalPanel)this.jPanelLamp).setState(SignalPanel.sStateGreen);
        
    }
    
    
/*
    private double findFreq(short[] dataS){
        if (actSkip==10)
            System.out.println("aa");
        if (searchPhase==SECOND_SEARCH){
            System.out.println("Entering with SECOND_SEARCH");
            int c=findCrossPoint(dataS,actualChannel,SLOPE_UP);
            if (lastGoodTransition==c)
                return 0;
            measStarted=false;
            System.out.println("GOT ");
            return samplingFreq/(c-lastGoodTransition);
        }
        if (searchPhase==FIRST_SEARCH){
            System.out.println("Entering with FIRST_SEARCH");
            int b=findCrossPoint(dataS,actualChannel,SLOPE_DOWN);
            if (b==-1)
                return 0;
            searchPhase=SECOND_SEARCH;
            System.out.println("Doing SECOND_SEARCH");
 
            int c=findCrossPoint(dataS,actualChannel,SLOPE_UP);
            if (lastGoodTransition==c)
                return 0;
            measStarted=false;
            System.out.println("GOT !");
 
            return samplingFreq/(c-lastGoodTransition);
        }
 
        if (searchPhase==PRE_SEARCH){
            System.out.println("Entering with PRE_SEARCH");
 
            int pr=findCrossPoint(dataS,actualChannel,SLOPE_UP);
            if (pr==-1)
                return 0;
            searchPhase=FIRST_SEARCH;
            System.out.println("Doing FIRST_SEARCH");
 
            int b=findCrossPoint(dataS,actualChannel,SLOPE_DOWN);
            if (b==-1)
                return 0;
            System.out.println("Doing SECOND_SEARCH");
 
            searchPhase=SECOND_SEARCH;
            int c=findCrossPoint(dataS,actualChannel,SLOPE_UP);
            if (lastGoodTransition==c)
                return 0;
            measStarted=false;
            System.out.println("GOT ");
 
            return samplingFreq/(c-lastGoodTransition);
        }
        return -1;
    }
 
    private int findCrossPoint(short[] dataS,int channel,int direction){
        //search cross point
        int i,lastPoint=-1;
        short trigL=0;
        if (channel==0)
            trigL=actualTrigLevel1;
        else
            trigL=actualTrigLevel2;
 
        //be sure we have at least 2 samples
        lastPoint=lastSearchPoint+channel;
        if (direction==SLOPE_UP){
            //where are we ?
 
            if (dataS[lastPoint]>trigThMinus){
                //discard this point go on until we fall below
                if (dataS[lastPoint]<trigThPlus){
                    //be sure we go over the high th
                    for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                        if (dataS[i]>trigThPlus){
                            lastPoint=i;
                            break;
                        }
                    }
                    if (i>=dataS.length-2*actSkip){
                        lastSearchPoint=i+2*actSkip-dataS.length-channel;
                        return -1;
                    }
                }
                //go on until below the low th
                for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                    if (dataS[i]<trigThMinus){
                        lastPoint=i;
                        break;
                    }
                }
                if (i>=dataS.length-2*actSkip){
                    lastSearchPoint=i+2*actSkip-dataS.length-channel;
 
                    return -1;
                }
            }
 
            //end of initial search
            //the first transition is good
            for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                if (dataS[i]>trigL){
                    return (i-channel)/2;
                }
            }
 
            //trig not found
 
            lastSearchPoint=i+2*actSkip-dataS.length-channel;
 
            return -1;
        }//end of slope up
        else{
            //slope down
            //where are we ?
            if (dataS[lastPoint]<trigThPlus){
                //discard the chunk go until below trig minus
                if (dataS[lastPoint]>trigThMinus){
                    for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                        if (dataS[i]<trigThMinus){
                            lastPoint=i;
                            break;
                        }
                    }
                    lastSearchPoint=i+2*actSkip-dataS.length-channel;
 
 
                    return -1;
                }
            }
            //now proceed until above trigplus
            for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                if (dataS[i]>trigThPlus){
                    lastPoint=i;
                    break;
                }
            }
            if (i>=dataS.length-2*actSkip){
                lastSearchPoint=i+2*actSkip-dataS.length-channel;
 
 
                return -1;
            }
 
        }
        //end of initial search
        //eventually get the trig point
        for (i=lastPoint;i<dataS.length;i+=2*actSkip){
            if (dataS[i]<trigL){
                //compute a fract part this is a forward position of the first returned sample
                return (i-channel)/2;
            }
        }
 
        //trig not found
        lastSearchPoint=i+2*actSkip-dataS.length-channel;
 
 
        return -1;
 
    }
 
 */
    
    
    private boolean getPrePrePosition(short[] dataS,int channel,int direction){
        //search first point
        int i,lastPoint=-1;
        short trigL=0;
        if (channel==0)
            trigL=actualTrigLevel1;
        else
            trigL=actualTrigLevel2;
        lastPoint=lastSearchPoint+channel;
        if (direction==SLOPE_UP){
            //where are we ?
            if (dataS[lastPoint]>trigThPlus){
                return true;
            }else{
                for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                    if (dataS[i]>trigThPlus){
                        lastSearchPoint=i;
                        return true;
                    }
                }
                //if (i>=dataS.length-2*actSkip){
                //could not reach a good position
                lastSearchPoint=i+2*actSkip-dataS.length-channel;
                return false;
                //}
            }
        }else{//SLOPE_DOWN
            if (dataS[lastPoint]<trigThMinus){
                return true;
            }else{
                for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                    if (dataS[i]<trigThMinus){
                        lastSearchPoint=i;
                        return true;
                        
                    }
                }
                //if (i>=dataS.length-2*actSkip){
                //could not reach a good position
                lastSearchPoint=i+2*actSkip-dataS.length-channel;
                return false;
                //}
            }
        }
    }
    
    
    
    private boolean getPrePosition(short[] dataS,int channel,int direction){
        //search first point
        int i,lastPoint=-1;
        short trigL=0;
        if (channel==0)
            trigL=actualTrigLevel1;
        else
            trigL=actualTrigLevel2;
        lastPoint=lastSearchPoint+channel;
        if (direction==SLOPE_UP){
            for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                if (dataS[i]<trigThMinus){
                    lastSearchPoint=i;
                    return true;
                    
                }
            }
            // if (i>=dataS.length-2*actSkip){
            //could not reach a good position
            lastSearchPoint=i+2*actSkip-dataS.length-channel;
            return false;
            //}
        }
        else{//SLOPE_DOWN
            for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                if (dataS[i]>trigThPlus){
                    lastSearchPoint=i;
                    return true;
                    
                }
            }
            //if (i>=dataS.length-2*actSkip){
            //could not reach a good position
            lastSearchPoint=i+2*actSkip-dataS.length-channel;
            return false;
            //}
        }
    }
    private boolean getTrigPosition(short[] dataS,int channel,int direction){
        //search first point
        int i,lastPoint=-1;
        short trigL=0;
        if (channel==0)
            trigL=actualTrigLevel1;
        else
            trigL=actualTrigLevel2;
        lastPoint=lastSearchPoint+channel;
        if (direction==SLOPE_UP){
            for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                if (dataS[i]>=trigL){
                    lastSearchPoint=i;
                    return true;
                    
                }
            }
            //if (i>=dataS.length-2*actSkip){
            //could not reach a good position
            lastSearchPoint=i+2*actSkip-dataS.length-channel;
            return false;
            //}
        }
        else{//SLOPE_DOWN
            for (i=lastPoint;i<dataS.length;i+=2*actSkip){
                if (dataS[i]<trigL){
                    lastSearchPoint=i;
                    return true;
                    
                }
            }
            //if (i>=dataS.length-2*actSkip){
            //could not reach a good position
            lastSearchPoint=i+2*actSkip-dataS.length-channel;
            return false;
            // }
        }
    }
    
    
    
    
    
    
    
    
    private String gateTimeAsString(int v){
        switch(v){
            case 0:
                return "   na";
            case 1:
                return " 50ms";
            case 2:
                return "100ms";
            case 3:
                return "200ms";
            case 4:
                return "500ms";
            case 5:
                return "   1s";
            case 6:
                return "   2s";
            case 7:
                return "   5s";
            default:
                return "   na";
                
                
        }
    }
    
    private String timeBaseAsString(int v){
        switch(v){
            case 0:
                return "2.2  kHz";
            case 1:
                return "4.4  kHz";
            case 2:
                return "11   kHz";
            case 3:
                return "22   kHz";
            case 4:
                return "44   kHz";
            default:
                return "44   kHz";
                
                
        }
    }
    
    public void setInputOffset(short newOffsetCh1, short newOffsetCh2) {
    }    
    
    public void useInputOffset(boolean use) {
    }    
    
    
    
    
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupChannels;
    private javax.swing.ButtonGroup buttonGroupMode;
    private javax.swing.ButtonGroup buttonGroupSlope1;
    private javax.swing.ButtonGroup buttonGroupSlope2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabelGate;
    private javax.swing.JLabel jLabelLevel1;
    private javax.swing.JLabel jLabelLevel2;
    private javax.swing.JLabel jLabelTimeBase;
    private javax.swing.JPanel jPanelGate;
    private javax.swing.JPanel jPanelLamp;
    private javax.swing.JPanel jPanelMode;
    private javax.swing.JPanel jPanelTimeBase;
    private javax.swing.JPanel jPanelTrigCh1;
    private javax.swing.JPanel jPanelTrigCh2;
    private javax.swing.JSlider jSliderGate;
    private javax.swing.JSlider jSliderLevel1;
    private javax.swing.JSlider jSliderLevel2;
    private javax.swing.JSlider jSliderTimeBase;
    private javax.swing.JTextField jTextFieldResult;
    private javax.swing.JToggleButton jToggleButton1to2;
    private javax.swing.JToggleButton jToggleButtonAuto;
    private javax.swing.JToggleButton jToggleButtonCh1;
    private javax.swing.JToggleButton jToggleButtonCh2;
    private javax.swing.JToggleButton jToggleButtonFreq;
    private javax.swing.JToggleButton jToggleButtonPeriod;
    private javax.swing.JToggleButton jToggleButtonSlopeDown1;
    private javax.swing.JToggleButton jToggleButtonSlopeDown2;
    private javax.swing.JToggleButton jToggleButtonSlopeUp1;
    private javax.swing.JToggleButton jToggleButtonSlopeUp2;
    // End of variables declaration//GEN-END:variables
    
    class FreqMonitor extends TimerTask{
        //this class is used to update the status and trig lamps
        
        
        public FreqMonitor() {
        }
        public void run() {
            if (measStarted){
                //flash the lamp during the measurement
                flashOn=!flashOn;
                if (flashOn){
                    ((SignalPanel)jPanelLamp).setState(SignalPanel.sStateBlue);
                }else{
                    ((SignalPanel)jPanelLamp).setState(SignalPanel.sStateGrey);
                    
                }
                
            }
        }//method run
    }//class monitor
    
}
