/*
 *  JPanelScope.java
 *  Created on January 29, 2002, 1:31 PM
 *  Version 1beta0
 *  @author  Marco Parvis
 */

/*
    Questo e' JPanelScope una parte di Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
    This is JPanelScope part of the Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
 */

/*
    Questo  programma e'  software  libero; e'  lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come e' pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.
 
    Questo programma  e' distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILITA'  o di  APPLICABILITA' PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.
 
    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne puo'
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA
 
    L'autore puo' essere contattato a parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 */

/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA
 
    The author can be contacted at parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 
 */


/*
 *  This panel simulates an oscilloscope with the following characteristics:
 *  Two channels AC coupled (due to board limitations)
 *  Time base 50us/dic to 200ms/div in 1-2-5 steps
 *  Input sensitivitites from 8000bit/div to 50bit/div in 1-2-4 steps
 *  Calibration capability
 *  Channel shift and ground
 *  Trigger up/down
 *  Delay
 *  Second Trigger
 *
 */

package JavaScope;

import java.awt.*;
//import java.awt.event.*;
//import java.awt.geom.Line2D;
import javax.swing.*;
//import javax.swing.event.*;
//import javax.swing.border.*;
import java.util.*;
//import java.util.Enumeration;
import java.io.*;
import javax.sound.sampled.*;
//import java.awt.font.*;
//import java.text.*;


public class JPanelScope extends javax.swing.JFrame  implements VirtualPanel{ // Observer{
    
    //  final int targetBufferSize=35280; //input buffer size 70560=44100*2*2*0.2 0.2s
    private String panelIdString;
    private boolean weAreInABench=false;
    private String lastSaveDir=new String(" ");
    private long tic,toc,tuc;
    
    
    private final int showSamples=8820;       //all the acquired samples used to show
    //1ms/div i.e. 10ms at 44100samples/s
    
    
    private final int TRIG_CH1=1;
    private final int TRIG_CH2=2;
    private final int TRIG_FREE=3;
    private final int TRIG_AUTO=0;
    private final int TRIG_NORM=1;
    private final int SLOPE_UP=0;
    private final int SLOPE_DOWN=1;
    private final int ACTIVE=1;
    private final int NOT_ACTIVE=0;
    
    
    private final int HIST=1000; //used for trigger purposes
    private final int XY_SAMPLES=1000;
    //--------------scope actual settings-----------------------
    
    //layout settings
    private int hControlWidth=300;
    private int triggerWidth=200;
    
    
    
    //general settings ----------------------
    private boolean displayCh1=true;
    private boolean displayCh2=true;
    private boolean useFilter=true;
    private boolean doXY=false;
    
    //vertical settings ---------------------
    private boolean useCalibrationFactor=false;
    private double calFactorVoltAtBitCh1=1;
    private double calFactorVoltAtBitCh2=1;
    private int actualSensitivityCh1=1;
    private int actualSensitivityCh2=1;
    private double actualMultCh1=1;
    private double actualMultCh2=1;
    private int actualShiftCh1=0;
    private int actualShiftCh2=0;
    private boolean gndCh1=false;
    private boolean gndCh2=false;
    private boolean uncalModeCh1=false;
    private int uncalExpanderCh1=1;  //this affects the display scale
    private boolean uncalModeCh2=false;
    private int uncalExpanderCh2=1;  //this affects the display scale
    
    //trigger settings -------------------------
    private int actualTrigMode=TRIG_CH1;
    private int actualAutoTrig=TRIG_AUTO;
    private int actualTrigSlope=SLOPE_UP;
    private int actualTrigLevel=0;
    private int actualDelayState=NOT_ACTIVE;
    private int actualDelayTriggeredState=NOT_ACTIVE;
    private int actualDelay=0;
    private int secondTrigMode=TRIG_CH1;
    private int secondTrigSlope=SLOPE_UP;
    private int secondTrigLevel=0;
    private long lastTrigTime=0;
    private boolean flashOn=false;
    private boolean isAutoTrig=false;
    private boolean waitForDelayToElapse=false;
    
    private int firstTrigPos=0;
    private boolean waitForFirstTrigger=true;
    private boolean waitForSecondTrigger=false;
    private double actualFractTrigger=0;
    
    private boolean weAreBelowLevel=true;
    
    //timebase settings ----------------------------------
    private boolean uncalXMode=false;
    private boolean uncalRequest=false; //this force an x computation
    private int uncalExpander=1;  //this affects the display scale
    private int actualTimeBase=4; //this affect used samples and skip coded value
    private int actualCapturedSamples=512;
    private int actualShownSamples=441;
    private int actualSampleSkip=2;
    
    
    private int w = 10; //last computed plot screen width
    private int h = 10; //last computed plot screen height;
    
    
    private int[] xScreen=new int[showSamples];    //x positions on plot screen
    
    
    
    private int[] yChannel1=new int[showSamples];  //scaled channels
    private int[] yChannel2=new int[showSamples];
    private int yChannel1Start=0;
    private int yChannel2Start=0;
    
    private int[] backYChannel1=new int[showSamples];  //copy in process
    private int[] backYChannel2=new int[showSamples];
    private int yChannel1StartBack=0;
    private int yChannel2StartBack=0;
    
    //variables for interpolation in the faster scale
    private int[] preTrigCh1=new int[32];
    private int[] preTrigCh2=new int[32];
    private boolean useInterp=false;
    private Fourier fManager=new Fourier();
    private final int interpExpander=16;
    private int[] xScreenE=new int[interpExpander*showSamples];    //x positions on plot screen
    private float[][] lut64=fManager.LUT(64); //  new float[32];
    private float[][] lutExp=fManager.LUT(64*interpExpander);
    float[][] in=new float[2][64];
    float[][] out=new float[2][64];
    float[][] inexp=new float[2][64*interpExpander];
    float[][] outexp=new float[2][64*interpExpander];
    //-----------------------------------------------------------
    
    private int gotBackSamples, lastSample;
    private boolean traceNeedToBeCompleted=false;
    private InputManager man;
    
    private ScopeTimeBaseSettings timeBaseSettings=new ScopeTimeBaseSettings();
    private ScopeSensitivitySettings sensitivityCh1=new ScopeSensitivitySettings();
    private ScopeSensitivitySettings sensitivityCh2=new ScopeSensitivitySettings();
    private ScopeDelaySetting   scopeDelay=new ScopeDelaySetting();
    
    private AudioInputStream audioInputStream;
    
    private java.util.Timer timerMonitor;
    private ScopeMonitor scopeMonitor;
    
    private short[] dataS;
    
    public void update(Observable o, Object arg){
        //new data arrived arg is  short[] and contains the samples in sequence
        //look for a trigger event
        tic=System.currentTimeMillis();
        //System.out.println("Scope update: "+tic);
        //short[]
        dataS=(short[])arg;
        //if xy no trigger research
        if (doXY){
            computeXYSamples(dataS);
            this.jPanelScreen.repaint();
            this.jTextField1.setText("Got");
            traceNeedToBeCompleted=false;
            waitForFirstTrigger=true;
            this.jTextField1.setText("XY");
            return;
        }
        //trigger was already found look for samples
        if (traceNeedToBeCompleted){
            if (computeSamples(dataS,0)){
                this.jPanelScreen.repaint();
                this.jTextField1.setText("Trace Complete");
                traceNeedToBeCompleted=false;
                waitForFirstTrigger=true;
                lastTrigTime=System.currentTimeMillis(); //this to avoid the monitor
                //to comply about missing trigger
                
            }
            else{
                traceNeedToBeCompleted=true;
                int perc=(100*gotBackSamples)/actualCapturedSamples;
                this.jTextField1.setText("Capturing:"+String.valueOf(perc)+"%");
            }
            return;
        }
        this.jTextField1.setText("Wait for trigger");
        if (waitForDelayToElapse){ //first trigger was found but delay not elapsed
            firstTrigPos-=dataS.length;
            if (firstTrigPos>dataS.length){
                return; //still waiting for delay
            }
            else{
                waitForDelayToElapse=false;
            }
            
        }//of wait for delattoelapse
        
        if (waitForSecondTrigger){//the delay was elapsed but the secondtrigger not found
            int x=secondTriggerPos(dataS,firstTrigPos);
            if (x<0){
                waitForSecondTrigger=true;
                firstTrigPos=0; //in the new chunk
                return;
            }
            else
                firstTrigPos=x; //ready to compute the samples
        }// we eventually got the trigger
        if (waitForFirstTrigger){
            firstTrigPos=triggerPos(dataS);
            if (firstTrigPos<0){
                return;
            }
            //first trigger found
            waitForFirstTrigger=false;
            if (firstTrigPos>dataS.length){
                waitForDelayToElapse=true;
                return;
            }
            if (actualDelayTriggeredState==ACTIVE){
                int x=secondTriggerPos(dataS,firstTrigPos);
                if (x<0){
                    waitForSecondTrigger=true;
                    firstTrigPos=0; //in the new chunk
                    return;
                }
                else
                    firstTrigPos=x;
            }
        }
        //eventually ready to compute the samples
        lastTrigTime=System.currentTimeMillis(); //save the last trigger time for red lamp on long wait
        //        System.out.println("Trig:"+lastTrigTime);
        if (computeSamples(dataS,firstTrigPos)){
            this.jTextField1.setText("Trace Complete");
            this.jPanelScreen.repaint();
            traceNeedToBeCompleted=false;
            waitForFirstTrigger=true;
            if (!isAutoTrig) //green lamp good trigger
                ((SignalPanel)this.jPanelLampTrig).setState(SignalPanel.sStateGreen);
            //          lastTrigTime=System.currentTimeMillis(); //save the last trigger time for red lamp on long wait
        }
        else{
            traceNeedToBeCompleted=true;
            //trave need to be colpleted is set within the compute sample
        }
    }
    private int secondTriggerPos(short[] dataS,int startPoint){
        int start=0,i,lastPoint=-1;
        short trigThPlus,trigThMinus;
        //be sure we have at least 2 samples
        switch (secondTrigMode){
            case TRIG_CH1:
                start=0;
                lastPoint=startPoint;
                break;
            case TRIG_CH2:
                start=1;
                lastPoint=startPoint+1;
                break;
            default:
                start=0;
                lastPoint=startPoint;
        }//of switch
        if ((secondTrigLevel+HIST)>Short.MAX_VALUE)
            trigThPlus=Short.MAX_VALUE;
        else
            trigThPlus=(short)(secondTrigLevel+HIST);
        
        if ((secondTrigLevel-HIST)>Short.MIN_VALUE)
            trigThMinus=(short)(secondTrigLevel-HIST);
        else
            trigThMinus=Short.MIN_VALUE;
        
        
        if (secondTrigSlope==SLOPE_UP){
            //where are we ?
            if (dataS[lastPoint]>trigThMinus){
                //discard this point go on until we fall below
                if (dataS[lastPoint]<trigThPlus){
                    //be sure we go over the high th
                    for (i=lastPoint;i<dataS.length;i+=2){
                        if (dataS[i]>trigThPlus){
                            lastPoint=i;
                            break;
                        }
                    }//of for
                    if (i==dataS.length){
                        return -1;
                    }
                }//of <trigThPlus
                //go on until below the low th
                for (i=lastPoint;i<dataS.length;i+=2){
                    if (dataS[i]<trigThMinus){
                        lastPoint=i;
                        break;
                    }
                }
                if (i==dataS.length){
                    return -1;
                }
            }//of trigminus
            //end of initial search
            //the first transition is good
            for (i=lastPoint;i<dataS.length;i+=2){
                if (dataS[i]>secondTrigLevel){
                    //compute a fract part this is a forward position of the first returned sample
                    actualFractTrigger=(double)(dataS[i]-secondTrigLevel)/(dataS[i]-dataS[i-2]);
                    return i-start;
                }
            }
            //trig not found
            return -1;
        }//end of slope up
        else{
            //slope down
            //where are we ?
            if (dataS[lastPoint]<trigThPlus){
                //discard the chunk go until below trig minus
                if (dataS[lastPoint]>trigThMinus){
                    for (i=lastPoint;i<dataS.length;i+=2){
                        if (dataS[i]<trigThMinus){
                            lastPoint=i;
                            break;
                        }
                    }
                    if (i==dataS.length){
                        return -1;
                    }
                }
                //now proceed until above trigplus
                for (i=lastPoint;i<dataS.length;i+=2){
                    if (dataS[i]>trigThPlus){
                        lastPoint=i;
                        break;
                    }
                }
                if (i==dataS.length){
                    return -1;
                }
            }
            //end of initial search
            //eventually get the trig point
            for (i=lastPoint;i<dataS.length;i+=2){
                if (dataS[i]<secondTrigLevel){
                    //compute a fract part this is a forward position of the first returned sample
                    actualFractTrigger=(double)(dataS[i]-secondTrigLevel)/(dataS[i]-dataS[i-2]);
                    return i-start;
                }
            }
            //trig not found
            return -1;
        }//of slope down
    }//of secondtrigger
    
    
    private int triggerPos(short[] dataS){
        //search trig position
        int start=0,i,lastPoint=-1;
        short trigThPlus,trigThMinus;
        
        int randStart=64+2*((int)(Math.random()*500)); //be sure it is even
        //be sure we have at least 2 samples
        switch (actualTrigMode){
            case TRIG_CH1:
                start=0;
                lastPoint=randStart;
                break;
            case TRIG_CH2:
                start=1;
                lastPoint=randStart+1;
                break;
            case TRIG_FREE:
                isAutoTrig=true;
                return randStart; //no search needed
            default:
                isAutoTrig=true;
                return randStart;
        }
        if ((actualTrigLevel+HIST)>Short.MAX_VALUE)
            trigThPlus=Short.MAX_VALUE;
        else
            trigThPlus=(short)(actualTrigLevel+HIST);
        
        if ((actualTrigLevel-HIST)>Short.MIN_VALUE)
            trigThMinus=(short)(actualTrigLevel-HIST);
        else
            trigThMinus=Short.MIN_VALUE;
        
        //System.out.println("start is:"+start+" trig min:"+trigThMinus+" trig max:"+trigThPlus);
        
        
        if (actualTrigSlope==SLOPE_UP){
            //where are we ?
            if (dataS[lastPoint]>trigThMinus){
                //discard this point go on until we fall below
                if (dataS[lastPoint]<trigThPlus){
                    //be sure we go over the high th
                    for (i=lastPoint;i<dataS.length;i+=2){
                        if (dataS[i]>trigThPlus){
                            lastPoint=i;
                            break;
                        }
                    }
                    if (i==dataS.length){
                        if (actualAutoTrig==TRIG_AUTO){
                            isAutoTrig=true;
                            return randStart;} //auto trig
                        else
                            return -1;
                    }
                }
                //go on until below the low th
                for (i=lastPoint;i<dataS.length;i+=2){
                    if (dataS[i]<trigThMinus){
                        lastPoint=i;
                        break;
                    }
                }
                if (i==dataS.length){
                    if (actualAutoTrig==TRIG_AUTO){
                        isAutoTrig=true;
                        return randStart;
                    } //auto trig
                    else
                        return -1;
                }
            }
            
            //end of initial search
            //the first transition is good
            for (i=lastPoint;i<dataS.length;i+=2){
                if (dataS[i]>actualTrigLevel){
                    //compute a fract part this is a forward position of the first returned sample
                    actualFractTrigger=(double)(dataS[i]-actualTrigLevel)/(dataS[i]-dataS[i-2]);
                    isAutoTrig=false;
                    if (actualDelayTriggeredState==ACTIVE)
                        waitForSecondTrigger=true;
                    if (actualDelayState==ACTIVE){
                        int x= i-start+2*actualDelay;
                        if (x>dataS.length)
                            waitForDelayToElapse=true;
                        else
                            waitForDelayToElapse=false;
                        return x;
                    }
                    else{
                        waitForDelayToElapse=false;
                        return i-start;
                    }
                }
            }
            //trig not found
            if (actualAutoTrig==TRIG_AUTO){
                isAutoTrig=true;
                return randStart; //auto trig
            }
            else
                return -1;
        }//end of slope up
        else{
            //slope down
            //where are we ?
            if (dataS[lastPoint]<trigThPlus){
                //discard the chunk go until below trig minus
                if (dataS[lastPoint]>trigThMinus){
                    for (i=lastPoint;i<dataS.length;i+=2){
                        if (dataS[i]<trigThMinus){
                            lastPoint=i;
                            break;
                        }
                    }
                    if (i==dataS.length){
                        if (actualAutoTrig==TRIG_AUTO){
                            isAutoTrig=true;
                            return randStart; //auto trig
                        }
                        else
                            return -1;
                    }
                }
                //now proceed until above trigplus
                for (i=lastPoint;i<dataS.length;i+=2){
                    if (dataS[i]>trigThPlus){
                        lastPoint=i;
                        break;
                    }
                }
                if (i==dataS.length){
                    if (actualAutoTrig==TRIG_AUTO){
                        isAutoTrig=true;
                        return randStart; //auto trig
                    }
                    else
                        return -1;
                }
            }
            //end of initial search
            //eventually get the trig point
            for (i=lastPoint;i<dataS.length;i+=2){
                if (dataS[i]<actualTrigLevel){
                    //compute a fract part this is a forward position of the first returned sample
                    actualFractTrigger=(double)(dataS[i]-actualTrigLevel)/(dataS[i]-dataS[i-2]);
                    isAutoTrig=false;
                    if (actualDelayTriggeredState==ACTIVE)
                        waitForSecondTrigger=true;
                    
                    if (actualDelayState==ACTIVE){
                        int x= i-start+2*actualDelay;
                        if (x>dataS.length)
                            waitForDelayToElapse=true;
                        else
                            waitForDelayToElapse=false;
                        return x;
                    }
                    else{
                        waitForDelayToElapse=false;
                        return i-start;
                    }
                }
            }
            //trig not found
            if (actualAutoTrig==TRIG_AUTO){
                isAutoTrig=true;
                return randStart; //auto trig
            }else
                return -1;
            
        }
    }
    private boolean computeSamples(short[] dataS,int start){
        float scalerCh1,scalerCh2;
        if (uncalModeCh1)
            scalerCh1=(float)((1.0+uncalExpanderCh1/25.0)*h/65536.0*actualMultCh1);
        else
            scalerCh1=(float)(h/65536.0*actualMultCh1);
        if (uncalModeCh2)
            scalerCh2=(float)((1.0+uncalExpanderCh2/25.0)*h/65536.0*actualMultCh2);
        else
            scalerCh2=(float)(h/65536.0*actualMultCh2);
        
        float shiftCh1=(float)(-h*actualShiftCh1/65536.0);
        float shiftCh2=(float)(-h*actualShiftCh2/65536.0);
        if (gndCh1)
            scalerCh1=0;
        if (gndCh2)
            scalerCh2=0;
        
        
        int half_h=h/2;
        int s=0;
        int availSamples;
        
        //if we have enough samples use them otherwise get as much as samples
        //we can and leave the others for later
        if (traceNeedToBeCompleted){
            start=actualSampleSkip+lastSample-dataS.length;
            if (start<0){
                System.out.println("Error start<0 composing a trace start:"+start+
                " sample skip:"+actualSampleSkip+" last sample:"+lastSample);
                start=0;}
            else if (start>dataS.length){
                System.out.println("Error OUT OF SAMPLES should be trapped by wait for delay");
                lastSample=start-actualSampleSkip;
                return false; //still out of available samples
            }
            
            s=start;
            
            availSamples=(dataS.length-start)/actualSampleSkip;
            if (availSamples<actualCapturedSamples-gotBackSamples){
                for (int x = gotBackSamples; x < gotBackSamples+availSamples; x++) {
                    backYChannel1[x]=half_h-(int)(dataS[s]*scalerCh1+shiftCh1);
                    backYChannel2[x]=half_h-(int)(dataS[s+1]*scalerCh2+shiftCh2);
                    s+=actualSampleSkip; //200*2 channels
                }
                gotBackSamples+=availSamples;
                lastSample=s;
                return false;
            }
            yChannel1Start=yChannel1StartBack;
            yChannel2Start=yChannel2StartBack;
            
            for (int x = 0;x<gotBackSamples;  x++) {
                yChannel1[x]=backYChannel1[x];
                yChannel2[x]=backYChannel2[x];
            }
            //update the samples
            for (int x = gotBackSamples; x < actualCapturedSamples; x++) {
                yChannel1[x]=half_h-(int)(dataS[s]*scalerCh1+shiftCh1);
                yChannel2[x]=half_h-(int)(dataS[s+1]*scalerCh2+shiftCh2);
                s+=actualSampleSkip; //200*2 channels
            }
            return true;
        }
        //new trace
        s=start;
        
        //this is a new trace so we can save pre samples in case an interpolation is required
        //the start point should be >32 thanks to the way the trigger is searched for
        if (actualSampleSkip==2 & useInterp){
            //System.out.println("new pretrig "+System.currentTimeMillis());
            if (start>64){
                int tmp=start-64;
                for (int i=0;i<32;i++){
                    preTrigCh1[i]=half_h-(int)(scalerCh1*dataS[tmp]+shiftCh1);
                    preTrigCh2[i]=half_h-(int)(scalerCh2*dataS[tmp+1]+shiftCh2);
                    tmp+=2;
                }
            }else
                System.out.println("Error: trace start before 32");
            
        }
        
        if (start<dataS.length){
            availSamples=(dataS.length-start)/actualSampleSkip;
            if (availSamples<actualCapturedSamples){
                yChannel1StartBack=half_h-
                (int)(shiftCh1+scalerCh1*(dataS[s]-((dataS[s]-dataS[s-2])*actualFractTrigger)));
                yChannel2StartBack=half_h-
                (int)(shiftCh2+scalerCh2*(dataS[s+1]-((dataS[s+1]-dataS[s-1])*actualFractTrigger)))/65536;
                for (int x = 0; x < availSamples; x++) {
                    backYChannel1[x]=half_h-(int)(scalerCh1*dataS[s]+shiftCh1);
                    backYChannel2[x]=half_h-(int)(scalerCh2*dataS[s+1]+shiftCh2);
                    s+=actualSampleSkip; //200*2 channels
                }
                gotBackSamples=availSamples;
                lastSample=s;
                return false;
            }
            //full available trace
            traceNeedToBeCompleted=false;
            yChannel1Start=half_h-
            (int)(shiftCh1+scalerCh1*(dataS[s]-((dataS[s]-dataS[s-2])*actualFractTrigger)));
            yChannel2Start=half_h-
            (int)(shiftCh2+scalerCh2*(dataS[s+1]-((dataS[s+1]-dataS[s-1])*actualFractTrigger)));
            for (int x = 0; x < actualCapturedSamples; x++) {
                yChannel1[x]=half_h-(int)(scalerCh1*dataS[s]+shiftCh1);
                yChannel2[x]=half_h-(int)(scalerCh2*dataS[s+1]+shiftCh2);
                s+=actualSampleSkip; //200*2 channels
            }
            return true;
        }else{
            //the delay push ourself beyond the data !
            System.out.println("ERROR OUT OF SAMPLES should be trapped by wait for delay");
            gotBackSamples=0;
            lastSample=s-actualSampleSkip;
            return false;
        }
    }
    
    
    
    private boolean computeXYSamples(short[] dataS){
        float scalerCh1,scalerCh2;
        if (uncalModeCh1)
            scalerCh1=(float)((1.0+uncalExpanderCh1/25.0)*h/65536.0*actualMultCh1);
        else
            scalerCh1=(float)(h/65536.0*actualMultCh1);
        if (uncalModeCh2)
            scalerCh2=(float)((1.0+uncalExpanderCh2/25.0)*w/65536.0*actualMultCh2);
        else
            scalerCh2=(float)(w/65536.0*actualMultCh2);
        
        
        float shiftCh1=(float)(-h*actualShiftCh1/65536.0);
        float shiftCh2=(float)(-w*actualShiftCh2/65536.0);
        if (gndCh1)
            scalerCh1=0;
        if (gndCh2)
            scalerCh2=0;
        int half_h=h/2;
        int half_w=w/2;
        int s=2*(int)(Math.random()*500);
        int skip=2*(((dataS.length-500)/2/XY_SAMPLES-1)/2);
        for (int x = 0; x < XY_SAMPLES; x++) {
            yChannel1[x]=half_h-(int)(scalerCh1*dataS[s]+shiftCh1);
            yChannel2[x]=half_w+(int)(scalerCh2*dataS[s+1]+shiftCh2);
            s+=skip; //200*2 channels
        }
        return true;
    }
    public String getSettings(){
        int x=this.getLocation().x;
        int y=this.getLocation().y;
        int w=this.getSize().width;
        int h=this.getSize().height;
        
        String s=panelIdString+"|Position="+String.valueOf(x)+","+String.valueOf(y)+"|Size="+String.valueOf(w)+","+String.valueOf(h)+"|";
        if (this.useCalibrationFactor)
            s=s+"UseInputCal=1|";
        else
            s=s+"UseInputCal=0|";
        s=s+"InputCalFactors="+String.valueOf(this.calFactorVoltAtBitCh1)+","+String.valueOf(this.calFactorVoltAtBitCh2);
        s=s+"|LastDir="+this.lastSaveDir;
        return s;
    }
    public void applySettings(String settings){
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        StringTokenizer tokens=new StringTokenizer(settings,"|");
        while (tokens.hasMoreTokens()){
            String token=tokens.nextToken();
            //browse through recognized tokens
            if (token.indexOf("Position=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<1) x=1;
                    if (x>screenSize.width-10) x=screenSize.width-10;
                    if (y<1) y=1;
                    if (y>screenSize.height-10) y=screenSize.height-10;
                    this.setLocation(x,y);
                }catch (Throwable t){}
                
            }else if (token.indexOf("Size=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<10) x=10;
                    if (x>screenSize.width-20) x=screenSize.width-20;
                    if (y<10) y=10;
                    if (y>screenSize.height-20) y=screenSize.height-20;
                    this.setSize(x,y);
                }catch (Throwable t){}
            }else if (token.indexOf("UseInputCal=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    if (x!=0)
                        this.useCalibrationFactor=true;
                    else
                        this.useCalibrationFactor=false;
                }catch (Throwable t){}
            }else if (token.indexOf("InputCalFactors=")>=0){
                String[] p=getValues(token);
                try{
                    double x=new Double(p[0]).doubleValue();
                    double y=new  Double(p[1]).doubleValue();
                    this.calFactorVoltAtBitCh1=x;
                    this.calFactorVoltAtBitCh2=y;
                }catch (Throwable t){}
                
            }else if (token.indexOf("LastDir=")>=0){
                String[] p=getValues(token);
                try{
                    this.lastSaveDir=p[0];
                }catch (Throwable t){}
            }
        }
        
    }
    private String[] getValues(String s){
        int peq=s.indexOf("=");
        if (peq>0){
            StringTokenizer ss=new StringTokenizer(s.substring(peq+1),",");
            if (ss.countTokens()>0){
                String[] vl=new String[ss.countTokens()];
                for (int i=0;i<vl.length;i++)
                    vl[i]=ss.nextToken();
                return vl;
            }else
                return new String[0];
            
        }else
            return new String[0];
    }
    public void useOutputCalibration(boolean use){
    }
    public void useInputCalibration(boolean use){
        this.useCalibrationFactor=use;
        setUpSensitivityCh1();
        setUpSensitivityCh2();
    }
    public void setOutputCalibration(double newCalCh1,double newCalCh2){
    }
    public void setInputCalibration(double newCalCh1,double newCalCh2){
        double actualFullScale=newCalCh1*32000; //newCal is voltAtBit
        double wantedFullScale=4*20e-3; //at gain 1
        calFactorVoltAtBitCh1=wantedFullScale/actualFullScale;
        actualFullScale=newCalCh2*32000; //newCal is voltAtBit
        calFactorVoltAtBitCh2=wantedFullScale/actualFullScale;
        setUpSensitivityCh1();
        setUpSensitivityCh2();
    }
    
    
    
    public void setOutputManager(OutputManager im){
    }
    public void setInputManager(InputManager im){
        this.man=im;
        man.addObserver(this);
    }
    public void setBenchComponent(boolean bc){
        weAreInABench=bc;
        if (bc)
            this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        else
            this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        
    }
    public void setIdString(String s){
        this.panelIdString=s;
        this.setTitle(s);
    }
    public String getIdString(){
        return this.panelIdString;
    }
    
    
    /** Creates new form JPanelScope */
    public JPanelScope(InputManager im){
        initComponents();
        setupTheControls();
        
        this.man=im;
        man.addObserver(this);
        scopeMonitor=new ScopeMonitor();
        timerMonitor=new java.util.Timer();
        timerMonitor.scheduleAtFixedRate(scopeMonitor,500,500);
        weAreInABench=false;
        
    }
    
    public JPanelScope() {
        initComponents();
        setupTheControls();
        scopeMonitor=new ScopeMonitor();
        timerMonitor=new java.util.Timer();
        timerMonitor.scheduleAtFixedRate(scopeMonitor,500,500);
        weAreInABench=false;
        this.setLocation(10,10);
        this.setSize(300,500);
    }
    
    
    private void setupTheControls(){
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        BoundedRangeModel brm;
        //dimensions of fixed size blocks
        hControlWidth=this.jPanelHControls.getPreferredSize().width;
        triggerWidth=this.jPanelTrigger.getPreferredSize().width;
        
        this.jPanelHControls.updateUI();
        this.jPanelTrigger.updateUI();
        //set the default values
        
        //----------- TRIGGER ----------------------
        this.jCheckBoxAutoTrig.setSelected(true);
        actualAutoTrig=TRIG_AUTO;
        this.jRadioButtonCh1.setSelected(true);
        actualTrigMode=TRIG_CH1;
        this.jRadioButtonTrigUp.setSelected(true);
        actualTrigSlope=SLOPE_UP;
        brm=jScrollBarLevel.getModel();
        brm.setMaximum(0);
        brm.setMaximum(32000);
        brm.setMinimum(-32000);
        brm.setValue(0);
        jScrollBarLevel.setModel(brm);
        jScrollBarLevel.setUnitIncrement(20);
        jScrollBarLevel.setBlockIncrement(500);
        actualTrigLevel=0;
        
        jCheckBoxUseDelay.setSelected(false);
        actualDelayState=NOT_ACTIVE;
        this.jLabelActualDelay.setEnabled(false);
        this.jScrollBarDelay.setEnabled(false);
        this.jCheckBoxDelayTriggered.setEnabled(false);
        actualDelayTriggeredState=NOT_ACTIVE;
        setEnableTrig(false);
        
        this.jRadioButtonSecondCh1.setSelected(true);
        secondTrigMode=TRIG_CH1;
        this.jRadioButtonSecondTrigUp.setSelected(true);
        secondTrigSlope=SLOPE_UP;
        
        brm=jScrollBarDelay.getModel();
        brm.setMaximum(0);
        brm.setMaximum(22050);
        brm.setMinimum(0);
        brm.setValue(0);
        jScrollBarDelay.setModel(brm);
        jScrollBarDelay.setBlockIncrement(50);
        actualDelay=0;
        
        brm=jScrollBarSecondLevel.getModel();
        brm.setMaximum(0);
        brm.setMaximum(32000);
        brm.setMinimum(-32000);
        brm.setValue(0);
        jScrollBarSecondLevel.setModel(brm);
        jScrollBarSecondLevel.setUnitIncrement(20);
        jScrollBarSecondLevel.setBlockIncrement(500);
        secondTrigLevel=0;
        
        
        jToggleButtonONCH1.setText("ON");       //channel 1 ON
        jToggleButtonONCH1.setSelected(true);
        displayCh1=true;
        jToggleButtonONCH2.setText("ON");       //channel 2 ON
        jToggleButtonONCH2.setSelected(true);
        displayCh2=true;
        jCheckBoxFilter.setSelected(true);      //use antialiasing
        useFilter=true;
        //init the time base
        brm=jScrollBarTimeBase.getModel();
        brm.setMaximum(0);
        brm.setMaximum(12); //0.1 0.2 0.5 1 2 5 10 20 50 100 ms/div
        brm.setMinimum(1);
        brm.setValue(5);
        jScrollBarTimeBase.setModel(brm);
        //init the vert scales
        brm=jScrollBarScaleCh1.getModel();
        brm.setMaximum(0);
        brm.setMaximum(8); // 5 10 20 50 100 200 500 1000 mv/div
        brm.setMinimum(1);
        brm.setValue(8);
        jScrollBarScaleCh1.setModel(brm);
        brm=jScrollBarPosCh1.getModel();
        brm.setMaximum(0);
        brm.setMaximum(32000); // 5 10 20 50 100 200 500 1000 mv/div
        brm.setMinimum(-32000);
        brm.setValue(0);
        
        jScrollBarPosCh1.setModel(brm);
        jScrollBarPosCh1.setBlockIncrement(200);
        jScrollBarPosCh1.setUnitIncrement(20);
        brm=jScrollBarScaleCh2.getModel();
        brm.setMaximum(0);
        brm.setMaximum(8);
        brm.setMinimum(1);
        brm.setValue(8);
        
        jScrollBarScaleCh2.setModel(brm);
        brm=jScrollBarPosCh2.getModel();
        brm.setMaximum(0);
        brm.setMaximum(32000); // 5 10 20 50 100 200 500 1000 mv/div
        brm.setMinimum(-32000);
        brm.setValue(0);
        jScrollBarPosCh2.setModel(brm);
        jScrollBarPosCh2.setBlockIncrement(200);
        jScrollBarPosCh2.setUnitIncrement(20);
        this.jScrollBarUncal.setEnabled(false);
        this.jScrollBarUncalCh1.setEnabled(false);
        this.jScrollBarUncalCh2.setEnabled(false);
        this.jTextField1.setText("");
        
        this.jCheckBoxSingleShot.setVisible(false);
        this.jCheckBoxFilter.setSelected(false);
        this.jCheckBoxFilter.setVisible(true);
        
        
    }
    private void setUpSensitivityCh1(){
        actualSensitivityCh1=jScrollBarScaleCh1.getValue();
        actualMultCh1=sensitivityCh1.getSensitivityMult(actualSensitivityCh1);
        if (useCalibrationFactor){
            actualMultCh1=actualMultCh1*calFactorVoltAtBitCh1;
        }
        this.jLabelActualScaleCh1.setText(sensitivityCh1.getSensitivityString(actualSensitivityCh1));
        //adjust the trigger value
        if (actualTrigMode==TRIG_CH1)
            actualTrigLevel=(int)(-jScrollBarLevel.getValue()/this.actualMultCh1);
        if (this.secondTrigMode==TRIG_CH1)
            secondTrigLevel=(int)(-jScrollBarSecondLevel.getValue()/this.actualMultCh1);
        
        
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }
    private void setUpSensitivityCh2(){
        actualSensitivityCh2=jScrollBarScaleCh2.getValue();
        actualMultCh2=sensitivityCh2.getSensitivityMult(actualSensitivityCh2);
        if (useCalibrationFactor){
            actualMultCh2=actualMultCh2*calFactorVoltAtBitCh2;
        }
        this.jLabelActualScaleCh2.setText(sensitivityCh2.getSensitivityString(actualSensitivityCh2));
        //adjust the trigger value
        if (actualTrigMode==TRIG_CH2)
            actualTrigLevel=(int)(-jScrollBarLevel.getValue()/this.actualMultCh2);
        if (this.secondTrigMode==TRIG_CH2)
            secondTrigLevel=(int)(-jScrollBarSecondLevel.getValue()/this.actualMultCh2);
        
        
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroupTriggerSource = new javax.swing.ButtonGroup();
        buttonGroupUpDown = new javax.swing.ButtonGroup();
        buttonGroupUpDownSecond = new javax.swing.ButtonGroup();
        buttonGroupSecondTriggerSource = new javax.swing.ButtonGroup();
        jPanelBase = new javax.swing.JPanel();
        jPanelVControlsCH2 = new javax.swing.JPanel();
        jToggleButtonONCH2 = new javax.swing.JToggleButton();
        jScrollBarScaleCh2 = new javax.swing.JScrollBar();
        jScrollBarPosCh2 = new javax.swing.JScrollBar();
        jLabelActualScaleCh2 = new javax.swing.JLabel();
        jCheckBoxGnd2 = new javax.swing.JCheckBox();
        jScrollBarUncalCh2 = new javax.swing.JScrollBar();
        jCheckBoxUncalCh2 = new javax.swing.JCheckBox();
        jPanelScreen = new ScopeScreen();
        jPanelVControlsCH1 = new javax.swing.JPanel();
        jToggleButtonONCH1 = new javax.swing.JToggleButton();
        jScrollBarScaleCh1 = new javax.swing.JScrollBar();
        jScrollBarPosCh1 = new javax.swing.JScrollBar();
        jLabelActualScaleCh1 = new javax.swing.JLabel();
        jCheckBoxGnd1 = new javax.swing.JCheckBox();
        jScrollBarUncalCh1 = new javax.swing.JScrollBar();
        jCheckBoxUncalCh1 = new javax.swing.JCheckBox();
        jPanelTrigger = new javax.swing.JPanel();
        jRadioButtonCh1 = new javax.swing.JRadioButton();
        jRadioButtonCh2 = new javax.swing.JRadioButton();
        jRadioButtonFree = new javax.swing.JRadioButton();
        jScrollBarLevel = new javax.swing.JScrollBar();
        jRadioButtonTrigUp = new javax.swing.JRadioButton();
        jRadioButtonTrigDown = new javax.swing.JRadioButton();
        jCheckBoxAutoTrig = new javax.swing.JCheckBox();
        //pre code !!!!!!
        jPanelLampTrig = new SignalPanel();
        jRadioButtonSecondTrigUp = new javax.swing.JRadioButton();
        jRadioButtonSecondTrigDown = new javax.swing.JRadioButton();
        jRadioButtonSecondCh1 = new javax.swing.JRadioButton();
        jRadioButtonSecondCh2 = new javax.swing.JRadioButton();
        jScrollBarSecondLevel = new javax.swing.JScrollBar();
        jPanelHControls = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        jCheckBoxFilter = new javax.swing.JCheckBox();
        jScrollBarTimeBase = new javax.swing.JScrollBar();
        jLabelActualTimeBase = new javax.swing.JLabel();
        jCheckBoxSingleShot = new javax.swing.JCheckBox();
        jCheckBoxXYMode = new javax.swing.JCheckBox();
        jScrollBarDelay = new javax.swing.JScrollBar();
        jLabelActualDelay = new javax.swing.JLabel();
        jCheckBoxUseDelay = new javax.swing.JCheckBox();
        jCheckBoxDelayTriggered = new javax.swing.JCheckBox();
        jScrollBarUncal = new javax.swing.JScrollBar();
        jCheckBoxUncal = new javax.swing.JCheckBox();
        jToolBarScope = new javax.swing.JToolBar();
        jButtonSaveTrace = new javax.swing.JButton();

        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanelBase.setLayout(null);

        jPanelBase.setBackground(java.awt.Color.pink);
        jPanelBase.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        jPanelBase.setMinimumSize(new java.awt.Dimension(100, 100));
        jPanelBase.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanelBaseComponentResized(evt);
            }
        });

        jPanelVControlsCH2.setLayout(null);

        jPanelVControlsCH2.setBorder(new javax.swing.border.TitledBorder("Channel 2"));
        jToggleButtonONCH2.setText("OFF");
        jToggleButtonONCH2.setToolTipText("Channel enable");
        jToggleButtonONCH2.setMaximumSize(new java.awt.Dimension(40, 15));
        jToggleButtonONCH2.setMinimumSize(new java.awt.Dimension(40, 15));
        jToggleButtonONCH2.setPreferredSize(new java.awt.Dimension(40, 15));
        jToggleButtonONCH2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonONCH2ActionPerformed(evt);
            }
        });

        jPanelVControlsCH2.add(jToggleButtonONCH2);
        jToggleButtonONCH2.setBounds(10, 20, 55, 20);

        jScrollBarScaleCh2.setPreferredSize(new java.awt.Dimension(10, 60));
        jScrollBarScaleCh2.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarScaleCh2AdjustmentValueChanged(evt);
            }
        });

        jPanelVControlsCH2.add(jScrollBarScaleCh2);
        jScrollBarScaleCh2.setBounds(12, 43, 18, 60);

        jScrollBarPosCh2.setToolTipText("Vertical Position");
        jScrollBarPosCh2.setPreferredSize(new java.awt.Dimension(10, 60));
        jScrollBarPosCh2.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarPosCh2AdjustmentValueChanged(evt);
            }
        });

        jPanelVControlsCH2.add(jScrollBarPosCh2);
        jScrollBarPosCh2.setBounds(130, 20, 18, 85);

        jLabelActualScaleCh2.setText("10mv/div");
        jLabelActualScaleCh2.setBorder(new javax.swing.border.TitledBorder("Sensitivity"));
        jPanelVControlsCH2.add(jLabelActualScaleCh2);
        jLabelActualScaleCh2.setBounds(60, 43, 70, 40);

        jCheckBoxGnd2.setText("gnd");
        jCheckBoxGnd2.setToolTipText("Ground sw.");
        jCheckBoxGnd2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxGnd2ActionPerformed(evt);
            }
        });

        jPanelVControlsCH2.add(jCheckBoxGnd2);
        jCheckBoxGnd2.setBounds(80, 20, 46, 20);

        jScrollBarUncalCh2.setToolTipText("Uncal up to 2.5x");
        jScrollBarUncalCh2.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarUncalCh2AdjustmentValueChanged(evt);
            }
        });

        jPanelVControlsCH2.add(jScrollBarUncalCh2);
        jScrollBarUncalCh2.setBounds(40, 43, 18, 60);

        jCheckBoxUncalCh2.setText("Unc.");
        jCheckBoxUncalCh2.setToolTipText("Uncal enable");
        jCheckBoxUncalCh2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxUncalCh2ActionPerformed(evt);
            }
        });

        jPanelVControlsCH2.add(jCheckBoxUncalCh2);
        jCheckBoxUncalCh2.setBounds(60, 80, 50, 24);

        jPanelBase.add(jPanelVControlsCH2);
        jPanelVControlsCH2.setBounds(400, 180, 160, 120);

        jPanelScreen.setBorder(new javax.swing.border.EtchedBorder());
        jPanelBase.add(jPanelScreen);
        jPanelScreen.setBounds(250, 10, 220, 150);

        jPanelVControlsCH1.setLayout(null);

        jPanelVControlsCH1.setBorder(new javax.swing.border.TitledBorder("Channel 1"));
        jToggleButtonONCH1.setText("OFF");
        jToggleButtonONCH1.setToolTipText("Channel enable");
        jToggleButtonONCH1.setMaximumSize(new java.awt.Dimension(40, 15));
        jToggleButtonONCH1.setMinimumSize(new java.awt.Dimension(40, 15));
        jToggleButtonONCH1.setPreferredSize(new java.awt.Dimension(40, 15));
        jToggleButtonONCH1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonONCH1ActionPerformed(evt);
            }
        });

        jPanelVControlsCH1.add(jToggleButtonONCH1);
        jToggleButtonONCH1.setBounds(10, 20, 55, 20);

        jScrollBarScaleCh1.setPreferredSize(new java.awt.Dimension(10, 60));
        jScrollBarScaleCh1.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarScaleCh1AdjustmentValueChanged(evt);
            }
        });

        jPanelVControlsCH1.add(jScrollBarScaleCh1);
        jScrollBarScaleCh1.setBounds(12, 43, 18, 60);

        jScrollBarPosCh1.setToolTipText("Vertical Position");
        jScrollBarPosCh1.setPreferredSize(new java.awt.Dimension(10, 60));
        jScrollBarPosCh1.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarPosCh1AdjustmentValueChanged(evt);
            }
        });

        jPanelVControlsCH1.add(jScrollBarPosCh1);
        jScrollBarPosCh1.setBounds(130, 20, 18, 85);

        jLabelActualScaleCh1.setText("10mV/div");
        jLabelActualScaleCh1.setBorder(new javax.swing.border.TitledBorder("Sensitivity"));
        jPanelVControlsCH1.add(jLabelActualScaleCh1);
        jLabelActualScaleCh1.setBounds(60, 43, 70, 40);

        jCheckBoxGnd1.setText("gnd");
        jCheckBoxGnd1.setToolTipText("Ground sw.");
        jCheckBoxGnd1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxGnd1ActionPerformed(evt);
            }
        });

        jPanelVControlsCH1.add(jCheckBoxGnd1);
        jCheckBoxGnd1.setBounds(80, 20, 46, 20);

        jScrollBarUncalCh1.setToolTipText("Uncal up to 2.5x");
        jScrollBarUncalCh1.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarUncalCh1AdjustmentValueChanged(evt);
            }
        });

        jPanelVControlsCH1.add(jScrollBarUncalCh1);
        jScrollBarUncalCh1.setBounds(40, 43, 18, 60);

        jCheckBoxUncalCh1.setText("Unc.");
        jCheckBoxUncalCh1.setToolTipText("Uncal enable");
        jCheckBoxUncalCh1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxUncalCh1ActionPerformed(evt);
            }
        });

        jPanelVControlsCH1.add(jCheckBoxUncalCh1);
        jCheckBoxUncalCh1.setBounds(60, 80, 50, 24);

        jPanelBase.add(jPanelVControlsCH1);
        jPanelVControlsCH1.setBounds(230, 180, 160, 120);

        jPanelTrigger.setLayout(new java.awt.GridBagLayout());

        jPanelTrigger.setBorder(new javax.swing.border.TitledBorder("Trigger"));
        jPanelTrigger.setMinimumSize(new java.awt.Dimension(40, 171));
        jPanelTrigger.setPreferredSize(new java.awt.Dimension(110, 227));
        jRadioButtonCh1.setText("Ch 1");
        buttonGroupTriggerSource.add(jRadioButtonCh1);
        jRadioButtonCh1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonCh1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonCh1, gridBagConstraints);

        jRadioButtonCh2.setText("Ch 2");
        buttonGroupTriggerSource.add(jRadioButtonCh2);
        jRadioButtonCh2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonCh2ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonCh2, gridBagConstraints);

        jRadioButtonFree.setText("Free");
        jRadioButtonFree.setToolTipText("Free run");
        buttonGroupTriggerSource.add(jRadioButtonFree);
        jRadioButtonFree.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonFreeActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonFree, gridBagConstraints);

        jScrollBarLevel.setToolTipText("Trigger level");
        jScrollBarLevel.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarLevelAdjustmentValueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipady = 39;
        gridBagConstraints.weighty = 10.0;
        jPanelTrigger.add(jScrollBarLevel, gridBagConstraints);

        jRadioButtonTrigUp.setToolTipText("Trig slope");
        buttonGroupUpDown.add(jRadioButtonTrigUp);
        jRadioButtonTrigUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonTrigUpActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonTrigUp, gridBagConstraints);

        jRadioButtonTrigDown.setText("-");
        jRadioButtonTrigDown.setToolTipText("Trig slope");
        buttonGroupUpDown.add(jRadioButtonTrigDown);
        jRadioButtonTrigDown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonTrigDownActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonTrigDown, gridBagConstraints);

        jCheckBoxAutoTrig.setText("Auto");
        jCheckBoxAutoTrig.setToolTipText("Enable auto triggering in the absence of trigger events");
        jCheckBoxAutoTrig.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxAutoTrigActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipady = 6;
        jPanelTrigger.add(jCheckBoxAutoTrig, gridBagConstraints);

        jPanelLampTrig.setMinimumSize(new java.awt.Dimension(12, 12));
        jPanelLampTrig.setPreferredSize(new java.awt.Dimension(12, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.ipadx = 2;
        gridBagConstraints.ipady = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        jPanelTrigger.add(jPanelLampTrig, gridBagConstraints);

        jRadioButtonSecondTrigUp.setText("+");
        jRadioButtonSecondTrigUp.setToolTipText("Secondary trig slope");
        buttonGroupUpDownSecond.add(jRadioButtonSecondTrigUp);
        jRadioButtonSecondTrigUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSecondTrigUpActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonSecondTrigUp, gridBagConstraints);

        jRadioButtonSecondTrigDown.setText("-");
        jRadioButtonSecondTrigDown.setToolTipText("Secondary trig slope");
        buttonGroupUpDownSecond.add(jRadioButtonSecondTrigDown);
        jRadioButtonSecondTrigDown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSecondTrigDownActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonSecondTrigDown, gridBagConstraints);

        jRadioButtonSecondCh1.setText("Ch 1");
        buttonGroupSecondTriggerSource.add(jRadioButtonSecondCh1);
        jRadioButtonSecondCh1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSecondCh1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonSecondCh1, gridBagConstraints);

        jRadioButtonSecondCh2.setText("Ch 2");
        buttonGroupSecondTriggerSource.add(jRadioButtonSecondCh2);
        jRadioButtonSecondCh2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSecondCh2ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelTrigger.add(jRadioButtonSecondCh2, gridBagConstraints);

        jScrollBarSecondLevel.setToolTipText("Second trigger level");
        jScrollBarSecondLevel.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarSecondLevelAdjustmentValueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 10.0;
        jPanelTrigger.add(jScrollBarSecondLevel, gridBagConstraints);

        jPanelBase.add(jPanelTrigger);
        jPanelTrigger.setBounds(120, 0, 110, 310);

        jPanelHControls.setLayout(new java.awt.GridBagLayout());

        jPanelHControls.setBorder(new javax.swing.border.TitledBorder("Time Base"));
        jPanelHControls.setPreferredSize(new java.awt.Dimension(120, 305));
        jTextField1.setText("jTextField4");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        jPanelHControls.add(jTextField1, gridBagConstraints);

        jCheckBoxFilter.setText("Interpolation");
        jCheckBoxFilter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxFilterActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        jPanelHControls.add(jCheckBoxFilter, gridBagConstraints);

        jScrollBarTimeBase.setOrientation(javax.swing.JScrollBar.HORIZONTAL);
        jScrollBarTimeBase.setToolTipText("Time Base");
        jScrollBarTimeBase.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarTimeBaseAdjustmentValueChanged(evt);
            }
        });
        jScrollBarTimeBase.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jScrollBarTimeBasePropertyChange(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        jPanelHControls.add(jScrollBarTimeBase, gridBagConstraints);

        jLabelActualTimeBase.setText("10ms/div");
        jLabelActualTimeBase.setBorder(new javax.swing.border.TitledBorder("Time Base"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        jPanelHControls.add(jLabelActualTimeBase, gridBagConstraints);

        jCheckBoxSingleShot.setText("Single Shot");
        jCheckBoxSingleShot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxSingleShotActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        jPanelHControls.add(jCheckBoxSingleShot, gridBagConstraints);

        jCheckBoxXYMode.setText("XY");
        jCheckBoxXYMode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxXYModeActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelHControls.add(jCheckBoxXYMode, gridBagConstraints);

        jScrollBarDelay.setOrientation(javax.swing.JScrollBar.HORIZONTAL);
        jScrollBarDelay.setToolTipText("Delay value");
        jScrollBarDelay.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarDelayAdjustmentValueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelHControls.add(jScrollBarDelay, gridBagConstraints);

        jLabelActualDelay.setText("0 ms");
        jLabelActualDelay.setToolTipText("Actual delay");
        jLabelActualDelay.setBorder(new javax.swing.border.TitledBorder("Delay"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelHControls.add(jLabelActualDelay, gridBagConstraints);

        jCheckBoxUseDelay.setText("Delay");
        jCheckBoxUseDelay.setToolTipText("Delay enable");
        jCheckBoxUseDelay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxUseDelayActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelHControls.add(jCheckBoxUseDelay, gridBagConstraints);

        jCheckBoxDelayTriggered.setText("Triggered");
        jCheckBoxDelayTriggered.setToolTipText("Second trigger enable");
        jCheckBoxDelayTriggered.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxDelayTriggeredActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelHControls.add(jCheckBoxDelayTriggered, gridBagConstraints);

        jScrollBarUncal.setOrientation(javax.swing.JScrollBar.HORIZONTAL);
        jScrollBarUncal.setToolTipText("Uncal up to 2.5x");
        jScrollBarUncal.setPreferredSize(new java.awt.Dimension(55, 17));
        jScrollBarUncal.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {
                jScrollBarUncalAdjustmentValueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 55;
        jPanelHControls.add(jScrollBarUncal, gridBagConstraints);

        jCheckBoxUncal.setText("Unc.");
        jCheckBoxUncal.setToolTipText("Uncal enable");
        jCheckBoxUncal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxUncalActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelHControls.add(jCheckBoxUncal, gridBagConstraints);

        jPanelBase.add(jPanelHControls);
        jPanelHControls.setBounds(0, 0, 120, 310);

        getContentPane().add(jPanelBase, java.awt.BorderLayout.CENTER);

        jButtonSaveTrace.setFont(new java.awt.Font("Dialog", 0, 10));
        jButtonSaveTrace.setIcon(new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/save.gif")));
        jButtonSaveTrace.setAlignmentY(0.0F);
        jButtonSaveTrace.setIconTextGap(0);
        jButtonSaveTrace.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonSaveTrace.setMinimumSize(new java.awt.Dimension(20, 24));
        jButtonSaveTrace.setPreferredSize(new java.awt.Dimension(20, 24));
        jButtonSaveTrace.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveTraceActionPerformed(evt);
            }
        });

        jToolBarScope.add(jButtonSaveTrace);

        getContentPane().add(jToolBarScope, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents
    
    private void jCheckBoxFilterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxFilterActionPerformed
        if (this.jCheckBoxFilter.isSelected())
            useInterp=true;
        else
            useInterp=false;
        // Add your handling code here:
    }//GEN-LAST:event_jCheckBoxFilterActionPerformed
    
    private void jCheckBoxSingleShotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxSingleShotActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_jCheckBoxSingleShotActionPerformed
    
    private void jScrollBarUncalCh2AdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarUncalCh2AdjustmentValueChanged
        uncalExpanderCh2=this.jScrollBarUncalCh2.getValue();
        // Add your handling code here:
    }//GEN-LAST:event_jScrollBarUncalCh2AdjustmentValueChanged
    
    private void jScrollBarUncalCh1AdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarUncalCh1AdjustmentValueChanged
        uncalExpanderCh1=this.jScrollBarUncalCh1.getValue();
    }//GEN-LAST:event_jScrollBarUncalCh1AdjustmentValueChanged
    
    private void jCheckBoxUncalCh2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxUncalCh2ActionPerformed
        if (jCheckBoxUncalCh2.isSelected()){
            this.uncalModeCh2=true;
            this.jScrollBarUncalCh2.setEnabled(true);
            this.jScrollBarScaleCh2.setEnabled(false);
            this.jLabelActualScaleCh2.setEnabled(false);
            
        }else{
            this.uncalModeCh2=false;
            this.jScrollBarUncalCh2.setEnabled(false);
            this.jScrollBarScaleCh2.setEnabled(true);
            this.jLabelActualScaleCh2.setEnabled(true);
        }
        this.jPanelVControlsCH2.updateUI();
        
    }//GEN-LAST:event_jCheckBoxUncalCh2ActionPerformed
    
    private void jCheckBoxUncalCh1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxUncalCh1ActionPerformed
        if (jCheckBoxUncalCh1.isSelected()){
            this.uncalModeCh1=true;
            this.jScrollBarUncalCh1.setEnabled(true);
            this.jScrollBarScaleCh1.setEnabled(false);
            this.jLabelActualScaleCh1.setEnabled(false);
            
        }else{
            this.uncalModeCh1=false;
            this.jScrollBarUncalCh1.setEnabled(false);
            this.jScrollBarScaleCh1.setEnabled(true);
            this.jLabelActualScaleCh1.setEnabled(true);
        }
        this.jPanelVControlsCH1.updateUI();
        
        
    }//GEN-LAST:event_jCheckBoxUncalCh1ActionPerformed
    
    private void jScrollBarUncalAdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarUncalAdjustmentValueChanged
        // Add your handling code here:
        uncalExpander=this.jScrollBarUncal.getValue();
        uncalRequest=true;
    }//GEN-LAST:event_jScrollBarUncalAdjustmentValueChanged
    
    private void jCheckBoxUncalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxUncalActionPerformed
        // Add your handling code here:
        if (jCheckBoxUncal.isSelected()){
            this.uncalXMode=true;
            this.jScrollBarUncal.setEnabled(true);
            this.jScrollBarTimeBase.setEnabled(false);
            this.jLabelActualTimeBase.setEnabled(false);
            
        }else{
            this.uncalXMode=false;
            this.jScrollBarUncal.setEnabled(false);
            this.jScrollBarUncal.setValue(0);
            this.jScrollBarTimeBase.setEnabled(true);
            this.jLabelActualTimeBase.setEnabled(true);
        }
        uncalRequest=true;
        this.jPanelHControls.updateUI();
        
    }//GEN-LAST:event_jCheckBoxUncalActionPerformed
    
    private void jScrollBarSecondLevelAdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarSecondLevelAdjustmentValueChanged
        // Add your handling code here:
        if (actualTrigMode==TRIG_CH1)
            secondTrigLevel=(int)(-jScrollBarSecondLevel.getValue()/this.actualMultCh1);
        else
            secondTrigLevel=(int)(-jScrollBarSecondLevel.getValue()/this.actualMultCh2);
        jScrollBarSecondLevel.setToolTipText("Level:"+String.valueOf(secondTrigLevel));
        
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jScrollBarSecondLevelAdjustmentValueChanged
    
    private void jRadioButtonSecondCh2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSecondCh2ActionPerformed
        // Add your handling code here:
        secondTrigMode=TRIG_CH2;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jRadioButtonSecondCh2ActionPerformed
    
    private void jRadioButtonSecondCh1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSecondCh1ActionPerformed
        // Add your handling code here:
        secondTrigMode=TRIG_CH1;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jRadioButtonSecondCh1ActionPerformed
    
    private void jRadioButtonSecondTrigUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSecondTrigUpActionPerformed
        // Add your handling code here:
        secondTrigSlope=SLOPE_UP;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jRadioButtonSecondTrigUpActionPerformed
    
    private void jRadioButtonSecondTrigDownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSecondTrigDownActionPerformed
        secondTrigSlope=SLOPE_DOWN;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jRadioButtonSecondTrigDownActionPerformed
    
    private void jCheckBoxGnd2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxGnd2ActionPerformed
        if (jCheckBoxGnd2.isSelected())
            gndCh2=true;
        else
            gndCh2=false;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }//GEN-LAST:event_jCheckBoxGnd2ActionPerformed
    
    private void jCheckBoxXYModeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxXYModeActionPerformed
        if (jCheckBoxXYMode.isSelected())
            doXY=true;
        else
            doXY=false;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jCheckBoxXYModeActionPerformed
    
    private void jCheckBoxGnd1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxGnd1ActionPerformed
        if (jCheckBoxGnd1.isSelected())
            gndCh1=true;
        else
            gndCh1=false;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jCheckBoxGnd1ActionPerformed
    
    private void jScrollBarPosCh1AdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarPosCh1AdjustmentValueChanged
        actualShiftCh1=jScrollBarPosCh1.getValue();
        jScrollBarPosCh1.setToolTipText("Pos:"+String.valueOf(actualShiftCh1));
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jScrollBarPosCh1AdjustmentValueChanged
    
    private void jScrollBarPosCh2AdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarPosCh2AdjustmentValueChanged
        actualShiftCh2=jScrollBarPosCh2.getValue();
        jScrollBarPosCh2.setToolTipText("Pos:"+String.valueOf(actualShiftCh2));
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jScrollBarPosCh2AdjustmentValueChanged
    
    private void jButtonSaveTraceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveTraceActionPerformed
        // Add your handling code here:
        saveThisTrace();
    }//GEN-LAST:event_jButtonSaveTraceActionPerformed
    
    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        // Add your handling code here:
    }//GEN-LAST:event_formComponentResized
    
    private void jScrollBarDelayAdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarDelayAdjustmentValueChanged
        actualDelay=jScrollBarDelay.getValue();
        this.jLabelActualDelay.setText(scopeDelay.getDelayString(actualDelay));
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }//GEN-LAST:event_jScrollBarDelayAdjustmentValueChanged
    
    private void jCheckBoxDelayTriggeredActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxDelayTriggeredActionPerformed
        if (jCheckBoxDelayTriggered.isSelected()){
            actualDelayTriggeredState=ACTIVE;
            setEnableTrig(true);
        }else{
            actualDelayTriggeredState=NOT_ACTIVE;
            setEnableTrig(false);
            waitForSecondTrigger=false;
        }
        
        
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }//GEN-LAST:event_jCheckBoxDelayTriggeredActionPerformed
    
    private void jCheckBoxUseDelayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxUseDelayActionPerformed
        if (jCheckBoxUseDelay.isSelected()){
            this.jLabelActualDelay.setEnabled(true);
            this.jScrollBarDelay.setEnabled(true);
            this.jCheckBoxDelayTriggered.setEnabled(true);
            actualDelayState=ACTIVE;
        }else{
            this.jLabelActualDelay.setEnabled(false);
            this.jScrollBarDelay.setEnabled(false);
            this.jCheckBoxDelayTriggered.setEnabled(false);
            this.jCheckBoxDelayTriggered.setSelected(false);
            actualDelayState=NOT_ACTIVE;
            actualDelayTriggeredState=NOT_ACTIVE;
            setEnableTrig(false);
        }
        waitForSecondTrigger=false;
        waitForDelayToElapse=false;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }//GEN-LAST:event_jCheckBoxUseDelayActionPerformed
    
    private void jRadioButtonTrigDownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonTrigDownActionPerformed
        actualTrigSlope=SLOPE_DOWN;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }//GEN-LAST:event_jRadioButtonTrigDownActionPerformed
    
    private void jRadioButtonTrigUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonTrigUpActionPerformed
        actualTrigSlope=SLOPE_UP;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }//GEN-LAST:event_jRadioButtonTrigUpActionPerformed
    
    private void jScrollBarLevelAdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarLevelAdjustmentValueChanged
        if (actualTrigMode==TRIG_CH1)
            actualTrigLevel=(int)(-jScrollBarLevel.getValue()/this.actualMultCh1);
        else
            actualTrigLevel=(int)(-jScrollBarLevel.getValue()/this.actualMultCh2);
        
        
        jScrollBarLevel.setToolTipText("Level:"+String.valueOf(actualTrigLevel));
        jScrollBarLevel.repaint();
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jScrollBarLevelAdjustmentValueChanged
    
    private void jCheckBoxAutoTrigActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxAutoTrigActionPerformed
        if (jCheckBoxAutoTrig.isSelected())
            actualAutoTrig=TRIG_AUTO;
        else{
            actualAutoTrig=TRIG_NORM;
            isAutoTrig=false;
        }
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }//GEN-LAST:event_jCheckBoxAutoTrigActionPerformed
    
    private void jRadioButtonFreeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonFreeActionPerformed
        actualTrigMode=TRIG_FREE;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jRadioButtonFreeActionPerformed
    
    private void jRadioButtonCh2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonCh2ActionPerformed
        actualTrigMode=TRIG_CH2;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
    }//GEN-LAST:event_jRadioButtonCh2ActionPerformed
    
    private void jRadioButtonCh1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonCh1ActionPerformed
        actualTrigMode=TRIG_CH1;
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
        
    }//GEN-LAST:event_jRadioButtonCh1ActionPerformed
    
    private void jScrollBarScaleCh2AdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarScaleCh2AdjustmentValueChanged
        setUpSensitivityCh2();
    }//GEN-LAST:event_jScrollBarScaleCh2AdjustmentValueChanged
    
    private void jScrollBarScaleCh1AdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarScaleCh1AdjustmentValueChanged
        setUpSensitivityCh1();
    }//GEN-LAST:event_jScrollBarScaleCh1AdjustmentValueChanged
    
    private void jScrollBarTimeBaseAdjustmentValueChanged(java.awt.event.AdjustmentEvent evt) {//GEN-FIRST:event_jScrollBarTimeBaseAdjustmentValueChanged
        actualTimeBase=jScrollBarTimeBase.getValue();
        jLabelActualTimeBase.setText(timeBaseSettings.getTimeBaseString(actualTimeBase));
        actualCapturedSamples=timeBaseSettings.getCapturedSamples(actualTimeBase);
        actualShownSamples=timeBaseSettings.getShownSamples(actualTimeBase);
        actualSampleSkip=timeBaseSettings.getSampleInterval(actualTimeBase);
        traceNeedToBeCompleted=false; //abort any queued trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jScrollBarTimeBaseAdjustmentValueChanged
    
    private void jScrollBarTimeBasePropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jScrollBarTimeBasePropertyChange
        // Add your handling code here:
    }//GEN-LAST:event_jScrollBarTimeBasePropertyChange
    
    private void jToggleButtonONCH2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonONCH2ActionPerformed
        if (jToggleButtonONCH2.isSelected()){
            jToggleButtonONCH2.setText("ON");
            displayCh2=true;
        }
        else{
            jToggleButtonONCH2.setText("OFF");
            displayCh2=false;
        }
        
    }//GEN-LAST:event_jToggleButtonONCH2ActionPerformed
    
    private void jToggleButtonONCH1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonONCH1ActionPerformed
        if (jToggleButtonONCH1.isSelected()){
            jToggleButtonONCH1.setText("ON");
            displayCh1=true;
        }
        else{
            jToggleButtonONCH1.setText("OFF");
            displayCh1=false;
        }
    }//GEN-LAST:event_jToggleButtonONCH1ActionPerformed
    
    private void jPanelBaseComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanelBaseComponentResized
        Dimension panelSize=this.jPanelBase.getSize();
        Point posHControl=this.jPanelHControls.getLocation();
        if (panelSize.height>2*posHControl.y){ //do we have space to show the panels ?
            this.jPanelHControls.setSize(hControlWidth,panelSize.height-2*posHControl.y);
            this.jPanelTrigger.setSize(triggerWidth,panelSize.height-2*posHControl.y);
        }
        int actualX=this.jPanelTrigger.getLocation().x+this.jPanelTrigger.getSize().width+1;
        
        //now setup the channel controls
        Dimension vControlDim=this.jPanelVControlsCH1.getSize();
        if (panelSize.width>actualX){
            this.jPanelVControlsCH1.setLocation(actualX,panelSize.height-vControlDim.height-posHControl.y);
            this.jPanelVControlsCH1.setSize((panelSize.width-actualX)/2,vControlDim.height);
            this.jPanelVControlsCH2.setLocation(actualX+(panelSize.width-actualX)/2,panelSize.height-vControlDim.height-posHControl.y);
            this.jPanelVControlsCH2.setSize((panelSize.width-actualX)/2,vControlDim.height);
        }
        //now setup the screen
        this.jPanelScreen.setLocation(actualX,posHControl.y);
        this.jPanelScreen.setSize((panelSize.width-actualX),panelSize.height-vControlDim.height-
        2*posHControl.y);
        this.jPanelHControls.updateUI();
        this.jPanelTrigger.updateUI();
        traceNeedToBeCompleted=false; //abort any ququed trace
        waitForFirstTrigger=true;
        
    }//GEN-LAST:event_jPanelBaseComponentResized
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        if (!weAreInABench){
            try{
                this.man.stopCapture();
            }
            catch(Throwable t){}
            System.exit(0);
        }
        else{
            int n = JOptionPane.showConfirmDialog(
            this,
            "This panel has been created by a bench manager. \n It should not be manually destroyed \n Are you SURE you want to continue?",
            "Alert",
            JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
            if (n==JOptionPane.YES_OPTION)
                this.dispose();
        }
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new JPanelScope().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupSecondTriggerSource;
    private javax.swing.ButtonGroup buttonGroupTriggerSource;
    private javax.swing.ButtonGroup buttonGroupUpDown;
    private javax.swing.ButtonGroup buttonGroupUpDownSecond;
    private javax.swing.JButton jButtonSaveTrace;
    private javax.swing.JCheckBox jCheckBoxAutoTrig;
    private javax.swing.JCheckBox jCheckBoxDelayTriggered;
    private javax.swing.JCheckBox jCheckBoxFilter;
    private javax.swing.JCheckBox jCheckBoxGnd1;
    private javax.swing.JCheckBox jCheckBoxGnd2;
    private javax.swing.JCheckBox jCheckBoxSingleShot;
    private javax.swing.JCheckBox jCheckBoxUncal;
    private javax.swing.JCheckBox jCheckBoxUncalCh1;
    private javax.swing.JCheckBox jCheckBoxUncalCh2;
    private javax.swing.JCheckBox jCheckBoxUseDelay;
    private javax.swing.JCheckBox jCheckBoxXYMode;
    private javax.swing.JLabel jLabelActualDelay;
    private javax.swing.JLabel jLabelActualScaleCh1;
    private javax.swing.JLabel jLabelActualScaleCh2;
    private javax.swing.JLabel jLabelActualTimeBase;
    private javax.swing.JPanel jPanelBase;
    private javax.swing.JPanel jPanelHControls;
    private javax.swing.JPanel jPanelLampTrig;
    private javax.swing.JPanel jPanelScreen;
    private javax.swing.JPanel jPanelTrigger;
    private javax.swing.JPanel jPanelVControlsCH1;
    private javax.swing.JPanel jPanelVControlsCH2;
    private javax.swing.JRadioButton jRadioButtonCh1;
    private javax.swing.JRadioButton jRadioButtonCh2;
    private javax.swing.JRadioButton jRadioButtonFree;
    private javax.swing.JRadioButton jRadioButtonSecondCh1;
    private javax.swing.JRadioButton jRadioButtonSecondCh2;
    private javax.swing.JRadioButton jRadioButtonSecondTrigDown;
    private javax.swing.JRadioButton jRadioButtonSecondTrigUp;
    private javax.swing.JRadioButton jRadioButtonTrigDown;
    private javax.swing.JRadioButton jRadioButtonTrigUp;
    private javax.swing.JScrollBar jScrollBarDelay;
    private javax.swing.JScrollBar jScrollBarLevel;
    private javax.swing.JScrollBar jScrollBarPosCh1;
    private javax.swing.JScrollBar jScrollBarPosCh2;
    private javax.swing.JScrollBar jScrollBarScaleCh1;
    private javax.swing.JScrollBar jScrollBarScaleCh2;
    private javax.swing.JScrollBar jScrollBarSecondLevel;
    private javax.swing.JScrollBar jScrollBarTimeBase;
    private javax.swing.JScrollBar jScrollBarUncal;
    private javax.swing.JScrollBar jScrollBarUncalCh1;
    private javax.swing.JScrollBar jScrollBarUncalCh2;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JToggleButton jToggleButtonONCH1;
    private javax.swing.JToggleButton jToggleButtonONCH2;
    private javax.swing.JToolBar jToolBarScope;
    // End of variables declaration//GEN-END:variables
    
    private void setEnableTrig(boolean actDl){
        this.jScrollBarSecondLevel.setEnabled(actDl);
        this.jRadioButtonSecondCh1.setEnabled(actDl);
        this.jRadioButtonSecondCh2.setEnabled(actDl);
        this.jRadioButtonSecondTrigDown.setEnabled(actDl);
        this.jRadioButtonSecondTrigUp.setEnabled(actDl);
        
        this.jScrollBarLevel.setEnabled(!actDl);
        this.jRadioButtonCh1.setEnabled(!actDl);
        this.jRadioButtonCh2.setEnabled(!actDl);
        this.jRadioButtonFree.setEnabled(!actDl);
        this.jCheckBoxAutoTrig.setEnabled(!actDl);
    }
    
    private void saveThisTrace(){
        ///
        JFileChooser fc=new JFileChooser();
        fc.setFileFilter(new javax.swing.filechooser.FileFilter() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return true;
                }
                String name = f.getName();
                if (name.endsWith(".dat")) {
                    return true;
                }
                return false;
            }
            public String getDescription() {
                return "Sample data files  (*.dat) ";
            }
        });
        fc.setCurrentDirectory(new File(lastSaveDir));
        if (fc.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
            String filename=new String(fc.getSelectedFile().getAbsolutePath());
            try {
                PrintWriter out
                = new PrintWriter(new BufferedWriter(new FileWriter(filename)));
                for (int i=0;i<dataS.length/2;i++){
                    out.print(dataS[2*i]);
                    out.println(dataS[2*i+1]);
                }
                
                out.close();}
            catch (IOException ie){
                System.out.println(ie.toString());
            }
            
            
        }
        
        
        ////
        
        
        
        
        
    }
    
    
    /********************************************************************/
    
    class ScopeScreen extends JPanel {
        
        public ScopeScreen() {
            setBackground(new Color(20, 20, 20));
        }
        public void update(Graphics g) {
            // Paint directly to avoid clearing the screen.
            paint(g);
        }
        
        
        private int[] interpolate(int[] pre,int[] signal,int backSamples){
            int[] yexp=new int[interpExpander*showSamples];
            
            float mean=0;
            int i;
            //first copy trailer and signal to float in
            for (i=0;i<32;i++){
                in[0][i]=pre[i];
                mean+=pre[i];
            }
            for (i=32;i<64;i++){
                in[0][i]=signal[i-32];
                mean+=signal[i-32];
            }
            //remove the mean
            mean=mean/64;
            for (i=0;i<64;i++){
                in[0][i]-=mean;
            }
            //do the fft
            fManager.DFT(in,out, lut64);
            //stuff the fft with zeros
            for (i=0;i<32;i++){
                outexp[0][i]=out[0][i];
                outexp[1][i]=out[1][i];
            }
            int sh=64*(interpExpander-1);
            for (i=32;i<64;i++){
                outexp[0][i+sh]=out[0][i];
                outexp[1][i+sh]=out[1][i];
            }
            //do an inverse fft
            fManager.IDFT(outexp, inexp, lutExp);
            //System.out.println(yChannel1[10]+"  "+in[0][42]+"  "+outexp[0][10]+" "+inexp[0][10]);
            sh=interpExpander*32-1-backSamples;
            //get back the oversampled result
            for (i=0;i<32*interpExpander+backSamples;i++)
                yexp[i]=(int)(mean+interpExpander*inexp[0][sh+i]);
            return yexp;
        }
        
        public void paint(Graphics g) {
            int i=0;
            double expX=1;
            int[] yExp1=null,yExp2=null;
            super.paint(g);
            Dimension d = getSize();
            int wn = d.width;
            int hn = d.height;
            if (wn!=w | hn!=h | uncalRequest){
                //the screen size has changed throw the  data
                w=wn;
                h=hn;
                if (uncalXMode)
                    expX=((1.0+uncalExpander/40.0)*w);
                else
                    expX=w;
                for (int j=0;j<showSamples;j++)
                    xScreen[j]=(int)(expX*j/showSamples);
                for (int j=0;j<interpExpander*showSamples;j++)
                    xScreenE[j]=(int)(expX*j/showSamples/interpExpander);
                
                
                uncalRequest=false;
                //return;
            }
            Graphics2D g2 = (Graphics2D) g;
            g2.setBackground(getBackground());
            g2.clearRect(0, 0, w, h);
            doGrid(g2); //    //draw the grid
            if (doXY){
                for (i = 1; i < XY_SAMPLES; i++) {
                    g2.drawLine(yChannel2[i-1],yChannel1[i-1],
                    yChannel2[i],yChannel1[i]);
                }
            }else {
                //plot the traces
                
                int actualXSkip=showSamples/actualShownSamples;
                int interSkip=(int)Math.round(actualFractTrigger*(xScreen[actualXSkip]-xScreen[0]));
                int backSamples=0;
                double remainder=0;
                if (actualShownSamples<32 & useInterp){
                    //attempt to interpolate.....
                    //since we interpolate we ahve some somples to fill up the initisal gap
                    backSamples=(int)(actualFractTrigger*interpExpander);
                    remainder=actualFractTrigger-backSamples/(float)interpExpander;
                    yExp1=interpolate(preTrigCh1, yChannel1,backSamples);
                    yExp2=interpolate(preTrigCh2, yChannel2,backSamples);
                    interSkip=(int)Math.round(remainder*(xScreenE[actualXSkip]-xScreenE[0]));
                
                    
                    //
                }
                
                
                
                if (displayCh1){
                    g2.setColor(Color.yellow);
                    if (actualShownSamples<32 & useInterp){
                        for (i = 1; i < interpExpander*actualShownSamples; i++) {
                            g2.drawLine(xScreenE[(i-1)*actualXSkip]+interSkip,yExp1[i-1],
                            xScreenE[i*actualXSkip]+interSkip,yExp1[i]);
                        }
                    }else{
                        
                        g2.drawLine(0,yChannel1Start,
                        interSkip,yChannel1[0]);
                        
                        for (i = 1; i < actualShownSamples; i++) {
                            g2.drawLine(xScreen[(i-1)*actualXSkip]+interSkip,yChannel1[i-1],
                            xScreen[i*actualXSkip]+interSkip,yChannel1[i]);
                        }
                        
                    }
                    
                }
                if (displayCh2){
                    g2.setColor(Color.red);
                    
                    if (actualShownSamples<32 & useInterp){
                        for (i = 1; i < interpExpander*actualShownSamples; i++) {
                            g2.drawLine(xScreenE[(i-1)*actualXSkip]+interSkip,yExp2[i-1],
                            xScreenE[i*actualXSkip]+interSkip,yExp2[i]);
                        }
                    }else{
                        
                        g2.drawLine(0,yChannel2Start,
                        interSkip,yChannel2[0]);
                        for (i = 1; i < actualShownSamples; i++) {
                            g2.drawLine(xScreen[(i-1)*actualXSkip]+interSkip,yChannel2[i-1],
                            xScreen[i*actualXSkip]+interSkip,yChannel2[i]);
                        }
                    }
                }
                if (isAutoTrig)
                    g2.drawString("Auto",20,20);
            }
        }
        private void doMessage(Graphics2D g2){
            g2.drawString("ciao",10,10);
        }
        private void doGrid(Graphics2D g2){
            int i=0;
            //do the main grid
            g2.setColor(Color.lightGray);
            for (i=1;i<=7;i++)
                g2.drawLine(0,(int)(h*i/8),w,(int)(h*i/8));
            for (i=1;i<=9;i++)
                g2.drawLine(w*i/10,0,w*i/10,h);
            //do the external box
            g2.setColor(Color.green);
            g2.drawLine(0,0,w-1,0);
            g2.drawLine(0,0,0,h-1);
            g2.drawLine(w-1,h-1,w-1,0);
            g2.drawLine(w-1,h-1,0,h-1);
            //do the axes
            g2.drawLine(0,h/2,w,h/2);
            g2.drawLine(w/2,0,w/2,h);
            //do the ticks
            int xMin=w/2-w/80;
            int xMax=w/2+w/80;
            for (i=1;i<40;i++)
                g2.drawLine(xMin,i*h/40,xMax,i*h/40);
            int yMin=h/2-h/72;
            int yMax=h/2+h/72;
            for (i=1;i<50;i++)
                g2.drawLine(i*w/50,yMin,i*w/50,yMax);
            
        }
        
    } // End class ScopeScreen
    class ScopeTimeBaseSettings {
        public ScopeTimeBaseSettings(){
        }
        String getTimeBaseString(int timeBaseCode){
            switch (timeBaseCode){
                case 1:
                    return "50 us/div";
                case 2:
                    return "100 us/div";
                case 3:
                    return "200 us/div";
                case 4:
                    return "500 us/div";
                case 5:
                    return "1ms/div";
                case 6:
                    return "2ms/div";
                case 7:
                    return "5ms/div";
                case 8:
                    return "10ms/div";
                case 9:
                    return "20ms/div";
                case 10:
                    return "50ms/div";
                case 11:
                    return "100ms/div";
                case 12:
                    return "200ms/div";
                default:
                    return "???ms/div";
            }
            
        }
        int getShownSamples(int timeBaseCode){
            switch (timeBaseCode){
                case 1:
                    return 22;
                case 2:
                    return 44;
                case 3:
                    return 88;
                case 4:
                    return 220;
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                case 10:
                case 11:
                case 12:
                    return 441;
                default:
                    return 441;
            }
            
        }
        int getCapturedSamples(int timeBaseCode){
            switch (timeBaseCode){
                case 1:
                    return 32;
                case 2:
                    return 64;
                case 3:
                    return 128;
                case 4:
                    return 256;
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                case 10:
                case 11:
                case 12:
                    return 512;
                default:
                    return 512;
            }
            
        }
        
        int getSampleInterval(int timeBaseCode){
            switch (timeBaseCode){
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                    return 2;
                case 6:
                    return 4;
                case 7:
                    return 10;
                case 8:
                    return 20;
                case 9:
                    return 40;
                case    10:
                    return 100;
                case 11:
                    return 200;
                case 12:
                    return 400;
                default:
                    return 40;
            }
            
        }
    }
    
    
    
    class ScopeSensitivitySettings {
        public ScopeSensitivitySettings(){
        }
        public String getSensitivityString(int sensitivityCode){
            if (!useCalibrationFactor){
                switch (sensitivityCode){
                    case 1:
                        return "50b/div"; // "200x";
                    case 2:
                        return "100b/div"; //"100x";
                    case 3:
                        return "200b/div"; //"40x";
                    case 4:
                        return "400b/div"; //"20x";
                    case 5:
                        return "800b/div"; //"10x";
                    case 6:
                        return "2000b/div"; //"4x";
                    case 7:
                        return "4000b/div"; //"2x";
                    case 8:
                        return "8000b/div"; //"1x";
                    default:
                        return "??";
                }//switch
            }
            else{
                
                switch (sensitivityCode){
                    case 1:
                        return "0.1mV/div";
                    case 2:
                        return "0.2mV/div";
                    case 3:
                        return "0.5mV/div";
                    case 4:
                        return "1mV/div";
                    case 5:
                        return "2mV/div";
                    case 6:
                        return "5mV/div";
                    case 7:
                        return "10mV/div";
                    case 8:
                        return "20mV/div";
                    default:
                        return "???mV/div";
                }
            }
        }//fet string
        
        
        public int getSensitivityMult(int sensitivityCode){
            switch (sensitivityCode){
                case 1:
                    return 200;
                case 2:
                    return 100;
                case 3:
                    return 40;
                case 4:
                    return 20;
                case 5:
                    return 10;
                case 6:
                    return 4;
                case 7:
                    return 2;
                case 8:
                    return 1;
                default:
                    return 1;
            }//switch
            
        }//getMult
    }//od scopesensitivitysetting
    
    class ScopeDelaySetting {
        public ScopeDelaySetting(){
        }
        public String getDelayString(int delayCode){
            double d;
            if (delayCode<=44){
                d=Math.round(delayCode/44100.0*1e6);
                return String.valueOf(d)+" us";
            }else if (delayCode<=440){
                d=Math.round(1e5*delayCode/44100.0)/100.0;
                return String.valueOf(d)+" ms";
            }else if (delayCode<=4400){
                d=Math.round(1e4*delayCode/44100.0)/10.0;
                return String.valueOf(d)+" ms";
            }else{
                d=Math.round(1e3*delayCode/44100.0);
                return String.valueOf(d)+" ms";
            }
        }
        
    }
    
    class ScopeMonitor extends TimerTask{
        //this class is used to update the status and trig lamps
        
        public ScopeMonitor() {
            //System.out.println("Timer created");
        }
        public void run() {
            if (doXY){
                ((SignalPanel)jPanelLampTrig).setState(SignalPanel.sStateYellow);
                return;
            }
            if (isAutoTrig){
                //if auto trig flash the green lamp
                flashOn=!flashOn;
                if (flashOn){
                    ((SignalPanel)jPanelLampTrig).setState(SignalPanel.sStateGreen);
                }else{
                    ((SignalPanel)jPanelLampTrig).setState(SignalPanel.sStateGrey);
                    
                }
            }
            else {
                if ((System.currentTimeMillis()-lastTrigTime)>1000){
                    //it a long time without trig
                    if (traceNeedToBeCompleted) //trace in process blue no trace red
                        ((SignalPanel)jPanelLampTrig).setState(SignalPanel.sStateBlue);
                    else
                        ((SignalPanel)jPanelLampTrig).setState(SignalPanel.sStateRed);
                }
            }
        }//method run
    }//class monitor
    
    
    
}