/*
 *  SignalPanel.java
 *  Created on January 29, 2002, 1:31 PM
 *  @version 1beta0
 *  @author  Marco Parvis
 */

/*    
    Questo e' SignalPanel una parte di Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
    
    This is SignalPanel part of the Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>

*/

/*
    Questo  programma e'  software  libero; e'  lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come e' pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e' distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILITA'  o di  APPLICABILITA' PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne puo'
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA

    L'autore puo' essere contattato a parvis@polito.it 
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
*/

/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA

    The author can be contacted at parvis@polito.it 
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy

*/


/*
 * This class provides a simple lamp with different colors
 */

package JavaScope;
import javax.swing.*;
import java.awt.*;
//import java.awt.event.*;

/**
 *
 * @author  admsermis
 */
public class SignalPanel extends javax.swing.JPanel {
	public static final int	sStateGrey = 0;
	public static final int	sStateYellow = 1;
	public static final int	sStateGreen = 2;
        public static final int	sStateRed = 3;
	public static final int	sStateCyan = 4;
	public static final int	sStateBlue = 5;
	public static final int	sStateMagenta = 6;
        
	private Image			mYellowDot;
	private Image			mRedDot;
	private Image			mGreenDot;
	private Image			mGreyDot;
        private Image			mBlueDot;
	private Image			mMagentaDot;
        private Image			mCyanDot;
        private boolean isCentered=false;
        private int startX=0;
        private int startY=0;
        private Dimension		mSize;
	private int				mState = 0;
    /** Creates new form SignalPanel */
    public SignalPanel() {
        initComponents();
        ImageIcon		icon;

        icon = new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/blue-ballT.gif"));
	mBlueDot = icon.getImage();
        icon = new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/cyan-ballT.gif"));
	mCyanDot = icon.getImage();
        icon = new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/green-ballT.gif"));
	mGreenDot = icon.getImage();
        icon = new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/magenta-ballT.gif"));
	mMagentaDot = icon.getImage();
        icon = new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/grey-ballT.gif"));
	mGreyDot = icon.getImage();
	icon = new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/yellow-ballT.gif"));
	mYellowDot = icon.getImage();
	icon = new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/red-ballT.gif"));
	mRedDot = icon.getImage();
	
        mSize = new Dimension(mGreenDot.getWidth(null), mGreenDot.getHeight(null));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        setLayout(new java.awt.BorderLayout());

    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

        public void setCentered(boolean c){
            this.isCentered=c;
        }
        public void setStartPoint(Point pt){
            this.startX=pt.x;
            this.startY=pt.y;
        }
        public void setStartPoint(int x,int y){
            this.startX=x;
            this.startY=y;
        }
        
    	public void setState(int state)	{
		mState = state;
		this.repaint();
	}

        public Dimension getPreferredSize()	{
		return mSize;
	}

	public Dimension getMinimumSize()	{
		return mSize;
	}
	public void update(Graphics g)	{
		// Paint directly to avoid clearing the screen.
		paint(g);
	}
	public void paint(Graphics g){
		super.paint(g);
                if (isCentered){
                    Dimension gm=this.getSize();
                    startX=(gm.width-mSize.width)/2;
                    startY=(gm.height-mSize.height)/2;
                }
		switch (mState){
        		case sStateGrey:
        			g.drawImage(mGreyDot, startX,startY, null);
				break;
			case sStateYellow:
				g.drawImage(mYellowDot, startX,startY, null);
				break;
			case sStateRed:
				g.drawImage(mRedDot, startX,startY, null);
				break;
			case sStateGreen:
				g.drawImage(mGreenDot, startX,startY, null);
				break;
			case sStateBlue:
				g.drawImage(mBlueDot, startX,startY, null);
				break;
			case sStateCyan:
				g.drawImage(mCyanDot, startX,startY, null);
				break;
			case sStateMagenta:
				g.drawImage(mMagentaDot, startX,startY, null);
				break;
		}

	}


    
}

