/*
 *  SplashScreen.java
 *  Created on January 29, 2002, 1:31 PM
 *  Version 1beta0
 *  @author  Marco Parvis
 */

/*
    Questo e' SplashScreen una parte di Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
    This is SplashScreen part of the Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
 */

/*
    Questo  programma e'  software  libero; e'  lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come e' pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.
 
    Questo programma  e' distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILITA'  o di  APPLICABILITA' PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.
 
    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne puo'
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA
 
    L'autore puo' essere contattato a parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 */

/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA
 
    The author can be contacted at parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 
 */

/* This class provides a splash screen with message capabilities
 */

package JavaScope;


import javax.swing.*;
import java.awt.*;
//import java.awt.event.*;
//import java.net.*;

public class SplashScreen extends JWindow {
    private Image	mBkgd;
    private String message="Initializing .....";
    private int lineHeight=100;
    private int descent=10;
    private int lineWidth=1;
    private FontMetrics fm=null;
    private int xMessage=120;
    private int yMessage=260;
    private boolean initialized=false;
    public SplashScreen()
    
    {
        ImageIcon icon;
        try{
            icon = new javax.swing.ImageIcon(getClass().getResource
            ("/JavaScope/resources/spl.gif"));
        }
        catch (Throwable t){
            return; //loadError=true;
        }
        
        
        
        mBkgd = icon.getImage();
        int xImage=mBkgd.getWidth(null);
        int yImage=mBkgd.getHeight(null);
        this.setSize(xImage - 2, yImage);
        xMessage=xImage/10;
        yMessage=(int)(yImage*.8);
        centerWindow(this);
        setVisible(true);
    }
    public void setMessage(String msg){
        this.message=msg;
        int newLineWidth;
        //compute line widht and height
        if (!initialized)
            newLineWidth=0;
        else
            newLineWidth=fm.charsWidth(message.toCharArray(),0,message.length());
        
        if (newLineWidth>lineWidth)
            this.repaint(xMessage-1,yMessage-lineHeight,newLineWidth+2,lineHeight+descent); //(60,220,350,50);
        else
            this.repaint(xMessage,yMessage-lineHeight,lineWidth+1,lineHeight+descent); //(60,220,350,50);
        this.lineWidth=newLineWidth;
        
    }
    public void update(Graphics g) {
        // Paint directly to avoid clearing the screen.
        paint(g);
    }
    
    
    public void paint(Graphics g) {
        super.paint(g);
        if (!initialized){
            Font f=new Font(this.getFont().getName(),Font.PLAIN,yMessage/20);;
            this.setFont(f);
            fm=((Graphics2D)this.getGraphics()).getFontMetrics();
            this.lineHeight=fm.getHeight();
            this.descent=+fm.getDescent();
            initialized=true;
        }
        Graphics2D g2=(Graphics2D)g;
        Dimension	size = getSize();
        g2.drawImage(mBkgd, -1, 0, null);
        g2.setColor(Color.darkGray);
        g2.drawRect(0, 0, size.width-1, size.height-1);
        g2.setColor(Color.yellow);
        
        g2.drawString(message, xMessage, yMessage);
        
    }
    
    
    
    static void centerWindow(Window win, Point offset) {
        Dimension	screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension	winSize = win.getSize();
        Rectangle	rect = new Rectangle(
        (screenSize.width - winSize.width) / 2 + offset.x,
        (screenSize.height - winSize.height) / 2 + offset.y,
        winSize.width, winSize.height);
        
        win.setBounds(rect);
    }
    static void centerWindow(Window win){
        Dimension	screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension	winSize = win.getSize();
        Rectangle	rect = new Rectangle(
        (screenSize.width - winSize.width) / 2,
        (screenSize.height - winSize.height) / 2,
        winSize.width, winSize.height);
        win.setBounds(rect);
    }
    
}




